*ATTENTION:
*change PC_FOLDER to the path where folder "chapter 3" is located on your computer
*example provided below
* pc folder
local PC_FOLDER "/Users/zhangjiwei/Desktop/UCLA/Boustan/Summer/Replication files/chapter 3"

clear 
set mem 600m 
set more off

/* Options 

global stat median ===> compute median earnings 
global stat mean   ===> compute mean   earnings 

* Occupational score versions:
==============================

with_owns_correction = 
= 0:  no correction for dwelling ownership 
= 1:  with correction for dwelling ownership 

*/




*global stat median 
global stat mean 


global with_owns_correction = 1 
loc folder "`PC_FOLDER'/Figure 3_earnings_gap"

* Globals +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
* Different versions of the occupational score (see above "Occupational score versions")  
global occscore_1960_WO                     "`folder'/auxiliary_files/aux_data_sets/occscore_by_race_and_region.dta"
global occscore_with_owns_correct           "`folder'/auxiliary_files/aux_data_sets/with_OWN_occscore_by_race_and_region"


* Paths:  do-files and data +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

* Raw IPUMS DATA
global IPUMS_DATA "`PC_FOLDER'/occupations/ipums"

* Auxiliary do files: 
global aux_do_files "`folder'/auxiliary_files/aux_do_files"

* Output folder
global output "`folder'/output"


* Set globlas to be used +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 

global occscore_1960 "$occscore_1960_WO"                     
global name "NO_owns_correct"
if $with_owns_correction == 1 {

global occscore_1960   "$occscore_with_owns_correct"                     
global name "with_owns_correct"


}



di "$name"

*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Compute median earnings by race using IPUMS census data and CPS
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


*do "`folder'//0_b_prepare_1880_1930_data.do"
*do "`folder'//1_ipums_new_1940_1970.do"
do "`folder'/2_CPS.do"


---
