



clear 
set mem 600m 



*Run aux. do-files
cap run "$aux_do_files/programs.do"
qui do "$aux_do_files/minimum_wages.do"

* Data folder
cap cd "$IPUMS_DATA"


* Open IPUMS raw data and clean the sample using 

loc prepare_data 0 

if `prepare_data'==1 {


foreach year in  1940 1950 1960 1970 {



use ipums_`year'

count 

do "$aux_do_files/Sample_Ipums.do"


count


save ipums_`year'_SAMPLE, replace

}

}







* +++++++++++++++++++++++++++++++++++++++++++++++
* Prepare occsocre_1960 
* +++++++++++++++++++++++++++++++++++++++++++++++

drop _all
use "$occscore_1960"
sort south black occ1950  
tempfile occscore_1960_sorted
save `occscore_1960_sorted'

use  ipums_1940_SAMPLE




* Correct occupation code


if $with_owns_correction==1 {

tab occ1950 if occ1950==100
tab ownershp if occ1950==100
gen ORIG_occ1950 = occ1950 

replace occ1950 = 820 if  occ1950==100 & ownershp==2


}

*sort black occ1950

*merge (black occ1950) using  $occscore_1960

sort south black occ1950 
merge (south black occ1950  ) using  `occscore_1960_sorted'


tab _merge

gen N_obs = . 
forvalues b = 0/1 {

replace  N_obs= N_black_`b'  if black ==`b'  

}

tab N_obs if _merge ==3
tab N_black_1 if _merge ==3 & black==1
tab N_black_0 if _merge ==3 & black==0


tab occ19 if _m==1

drop if _m ==2

drop if _m==1 & classwkr==1


save ipums_1940_SAMPLE_with_OCCSCORE, replace


foreach year in 1950 1960 1970 {

append using ipums_`year'_SAMPLE

}


gen income= .
replace  income= incwage           if classwkr==2 & year ==1940
replace  income= occscore_1960     if classwkr==1 &  year ==1940
replace  income= inctot            if year > 1940 



drop if year ==1940 & classwkr== 0 
tab year if income==.



bys south black: sum income if year==1940, d






* clean 
gen aprox_hours = 35*50

gen aprox_hourly_wages= income/aprox_hours

/*
count if aprox_hourly_wages> 0 & aprox_hourly_wages<. 
count if aprox_hourly_wages> 0 & aprox_hourly_wages<.  & aprox_hourly_wages<min_WAGE
count if aprox_hourly_wages> 0 & aprox_hourly_wages<.  & aprox_hourly_wages<min_WAGE/2
count if aprox_hourly_wages> 0 & aprox_hourly_wages<.  & aprox_hourly_wages<min_WAGE/2 & classwkr==1 
 */ 














* "estimated" hourly wages









gen cpi=.

	    



do "$aux_do_files/replace_CPI.do" 	 
 	 
 	 
	 
 

* earnings (deflacted)
gen earnings = income*cpi  
sum earnings, d










gen earnings_A = earnings

replace earnings_A = . if  /*aprox_hourly_wages> 0 &*/ aprox_hourly_wages<.  & aprox_hourly_wages<min_WAGE/2 & classwkr==2 


gen log_earnings_A =log(earnings_A)



gen earnings_B = earnings

replace earnings_B = (min_WAGE/2)*40*50*cpi  if   aprox_hourly_wages<min_WAGE/2 & classwkr==2 

gen log_earnings_B =log(earnings_B)




gen earnings_C = earnings


gen log_earnings_C =log(earnings_C)















tempfile final_data_earnings
save `final_data_earnings'




* =======================================================================
* NATIONAL
* =======================================================================

use `final_data_earnings'

collapse ($stat) log_earnings_A log_earnings_B log_earnings_C earnings [w = hhwt], by(year black)






reshape wide log_earnings_A log_earnings_B log_earnings_C earnings, i(year) j(black)


foreach type in A B C {

gen gap_`type'=   log_earnings_`type'0 - log_earnings_`type'1

}



sort year 

outsheet using NACIONAL_ipums.xls, replace

save NACIONAL_ipums.dta, replace


* =======================================================================
* by region
* =======================================================================


use `final_data_earnings'



collapse ($stat) log_earnings_A log_earnings_B log_earnings_C earnings[w = hhwt], by(year black south)

/*
* For the returns to migration

replace earnings = . if earnings<=0

collapse (mean) earnings[w = hhwt], by(year black south)

*/




reshape wide log_earnings_A log_earnings_B log_earnings_C earnings, i(year south) j(black)


foreach type in A B C{

gen gap_`type'=   log_earnings_`type'0 - log_earnings_`type'1

}



save REGIONAL_ipums.dta, replace




















/*




gr7 gap_A gap_B year

twoway (scatter gap_A year) (scatter gap_B year), ytitle(log(white earnings)- log(black earnings)) xtitle(year) legend(order(1 "Earnings gap I " 2 "Earnings gap II")) scheme(sj)



*/


















