

/* doubts:

1) I computed first log(wage) and then the average by race
2) I used total earnings (not hourly earnings)
3) earnings 2 also for those with "0" eranings  (aged 18-64, not in school, not in the army, etc.)

*/











loc add_1880_1930 = 1




di "$name"


*Run aux. do-files
 
 cd "$aux_do_files"

cap run "$aux_do_files/programs.do"
qui do "$aux_do_files/minimum_wages.do"

* Data folder
cap cd "$IPUMS_DATA"


* Prepare CPS data

loc prepare_CPS= 0

if `prepare_CPS' == 1 {

use cps_1962_2012






keep if sex==1

keep if age>=18 & age<=64

keep if gq==1|gq==.

drop if empstat==13 |empstat==33

drop if empstat==13 |empstat==33

drop if schlcoll>0 & schlcoll<5

drop if race>200

save cps_1962_2012_SAMPLE, replace


*/




* stats

use cps_1962_2012_SAMPLE



drop if year<1964





sort year 

merge (year) using min_WAGE

tab _merge

tab year if _merge==2 
drop if _merge==2

drop _merge




* south

gen south = (region==31|region==32|region==33)
replace south = 0 if (statefip==10|statefip==11 |statefip==24|statefip==29)

* "estimated" hourly wages

/*

Codes
99999999 = N.I.U. (Not in Universe). 
99999998 = Missing. 
Values can be negative.


*/
gen income = inctot

replace income = . if income ==999999
replace income = . if income ==999998
replace income = . if income ==99999999
replace income = . if income ==99999998 




replace income = . if income >99999997

local code1 ""
local code2 ""

forvalues i = 1/15 {


local code1 "`code1'9"
local code2 "`code1'8"

di "codes: `code1' , `code2' "

count if inctot> `code1' -0.1 &  inctot< `code1' + 0.1 
count if inctot> `code2' -0.1 &  inctot< `code2' + 0.1 

}





gen aprox_hours = 35*50

gen aprox_hourly_wages= income/aprox_hours

count if aprox_hourly_wages> 0 & aprox_hourly_wages<. 
count if aprox_hourly_wages> 0 & aprox_hourly_wages<.  & aprox_hourly_wages<min_WAGE
count if aprox_hourly_wages> 0 & aprox_hourly_wages<.  & aprox_hourly_wages<min_WAGE/2






* cpi
gen cpi= .


do "$aux_do_files/replace_CPI.do"


* earnings (deflacted)
gen earnings = income*cpi

gen earnings_A = earnings

replace earnings_A = . if  /*aprox_hourly_wages> 0 & */ aprox_hourly_wages<.  & aprox_hourly_wages<min_WAGE/2  &  classwkr>20 & classwkr<29

gen log_earnings_A =log(earnings_A)



gen earnings_B = earnings

replace earnings_B = (min_WAGE/2)*40*50*cpi if   aprox_hourly_wages<min_WAGE/2 & classwkr>20 & classwkr<29    // deberian ser solo para los que tiene ingreso positivo?????

count if earnings_B==.
count if earnings_B==.  & income ==999998


gen log_earnings_B =log(earnings_B)


gen earnings_C = earnings
gen log_earnings_C = log(earnings)









* black vs white

gen black = race==200 if race<300
keep if black !=.


tempfile final_data_earnings
save    `final_data_earnings'

* =======================================================================
* NACIONAL
* =======================================================================

use `final_data_earnings'



collapse ($stat) log_earnings_A log_earnings_B log_earnings_C earnings [w= hwtsupp], by(year black)


reshape wide log_earnings_A log_earnings_B log_earnings_C earnings, i(year) j(black)


foreach type in A B C{

gen gap_`type'=   log_earnings_`type'0 - log_earnings_`type'1

label var gap_`type' "Earnings Gap"

}


sort year 

outsheet using NACIONAL_CPS.xls, replace


save NACIONAL_cps_1962_2012.dta, replace




* =======================================================================
* by region
* =======================================================================

use `final_data_earnings'

collapse ($stat) log_earnings_A log_earnings_B log_earnings_C earnings [w= hwtsupp], by(year black south)







reshape wide log_earnings_A log_earnings_B log_earnings_C earnings, i(year south) j(black)


foreach type in A B C {

gen gap_`type'=   log_earnings_`type'0 - log_earnings_`type'1

label var gap_`type' "Earnings Gap"


}



save REGIONAL_cps_1962_2012.dta, replace

}


*###########################################==============#####################################*
*###########################################    APPEND    #####################################*
*###########################################==============#####################################*

drop _all

use REGIONAL_cps_1962_2012.dta
gen CPS_data= 1

append using REGIONAL_ipums.dta


di _n(20) "name= $name" _n(20) 


if `add_1880_1930' == 1 {


append using REGIONAL_ipums_1880_1930.dta



}


tempfile REGIONAL
save `REGIONAL'







* SOuth 
	drop _all
	use `REGIONAL'
	keep if south ==1
	tempfile data_south 
	save `data_south'

* North
	drop _all
	use `REGIONAL'
	keep if south ==0
	tempfile data_north 
	save `data_north'



if `add_1880_1930' != 1 {

* National
	drop _all 
	use NACIONAL_cps_1962_2012.dta
	append using  NACIONAL_ipums.dta
	tempfile data_national 
	save `data_national'

}



if `add_1880_1930' == 1 {

*	drop _all 
	use NACIONAL_cps_1962_2012.dta
	append using  NACIONAL_ipums.dta
	append using NACIONAL_ipums_1880_1930.dta

	tempfile data_national 
	save `data_national'


}






*###########################################==============#####################################*
*###########################################    graphs    #####################################*
*###########################################==============#####################################*


foreach region in north south national {  

drop _all
use `data_`region''

/*(!!!!!!!!!!!!!!!!new!!!!!!!!!!!!!!)*/
drop if year < 1940 

sum year 

loc year_0 = r(min)
loc year_0_2 = r(min) - 2

loc delta 10
if r(min) < 1940 loc delta 20

* Nacional

 
keep if year <2011

* order(1 "Earnings gap I " 2 "Earnings gap II" 3 "Earnings gap III" )
local graphs_GAP "(scatter gap_A year) (scatter gap_B year) (scatter gap_C year)"

*gr export "$output\NATIONAL_earnings_gap.png" , replace



local A I 
local B II
local C III


loc types "A "

foreach type in `types' {

local ymax 1.6
local ymax 1

* Wage gap
local graphs_GAP "(scatter gap_`type' year)"
pe twoway `graphs_GAP' , graphr(m(zero))  ytitle(log(white earnings)- log(black earnings)) xtitle(year) legend(on region(fcolor(none) lcolor(none)) region(fcolor(none) lcolor(none))) scheme(s1mono) plotregion(lcolor(none)) yscale(range(1 0)) xscale(range(`year_0_2' 2014)) xlabel(`year_0'(`delta')2014)  ylabel(0(0.2)`ymax')  


graph save `region'_gap_`type'.gph, replace

gr export "$output/`name'_`region'____ONLY___GAP_``type''.png" , replace


* Levels
twoway (scatter log_earnings_`type'0 year) (scatter log_earnings_`type'1 year), graphr(m(zero))  ytitle(log(earnings)) xtitle(year) legend(order(1 " Whites" 2 "Blacks")  region(fcolor(none) lcolor(none))) scheme(s1mono) plotregion(lcolor(none)) yscale(range(8 11)) xscale(range(`year_0_2' 2014)) xlabel(`year_0'(`delta')2014)  ylabel(8(0.5)11)
graph save levels_`type'.gph, replace

* Combine both graphs together
graph combine levels_`type'.gph `region'_gap_`type'.gph , scheme(s1mono) plotregion(lcolor(none))

di _n(20) "name= $name" _n(20) 
loc name = "$name"
di "gr export $output/`name'_`region'_earnings_``type''.png , replace"
gr export "$output/`name'_`region'_earnings_``type''.png" , replace



sort year

outsheet   year gap_A log_earnings_`type'0 log_earnings_`type'1 using "$output/`name'_`region'_earnings_``type''.xls", replace

* 0 = whites, 1 = blacks

cap shell erase *.gph

}

}


---



