
cap program drop max_household_string
cap program define max_household_string

syntax , gen(string) x(string)  id(string) 

gen `gen' = `x'
bysort `id' (`gen'): replace `gen' = `gen'[_N]

end





* sets  (e.g. 1890-1900, 1900-1910, etc.)

cap program drop create_sets 
program define create_sets , rclass

syntax anything

loc s 0 
foreach y in  `anything' {

loc y0 "`y1'" 
loc y1 "`y'" 

if `s'>0 {


local set`s' "`y0' `y1'" 
ret local set`s' = "`set`s''"

}



loc ++s 
}

ret scalar N= `s'-1

end


cap program drop interpolate_many_values
program define interpolate_many_values


syntax, vars(varlist) vars_years(numlist) year(varlist) gen(string)  




foreach macro in vars vars_years {

create_sets ``macro''

loc N = r(N)

forvalues i = 1/`N' {

local set_`i'_`macro' = r(set`i')

di "`set_`i'_`macro''"

}


}


gen `gen' = . 

forvalues i = 1/`N' {

di _n(5) "`set_`i'_vars' , `set_`i'_vars_years'" 


interpolate, vars(`set_`i'_vars') vars_years(`set_`i'_vars_years') year(`year') gen (___iNt`i')


tokenize `set_`i'_vars_years'

replace `gen' = ___iNt`i' if `gen'==. & `year'>=`1' & `year'<=`2'


}



cap drop ___iNt*



end 







cap program drop interpolate
program define interpolate


syntax, vars(varlist) vars_years(numlist) year(varlist) gen(string)


tokenize `vars'

loc X_T1 `1'
loc X_T2 `2'


tokenize `vars_years'

loc T1 `1'
loc T2 `2'




tempvar slope

gen `gen' =  `X_T1' + (`year' - `T1')*((`X_T2' - `X_T1')/ (`T2'-`T1')) if `year'>=`T1' & `year'<=`T2'

end 






cap program drop extrapolate
program define extrapolate


syntax, years(numlist) vars_2_extrapolate(varlist) years_2_extrapolate(numlist) year(varlist) gen(string)


tokenize  `vars_2_extrapolate'

loc X_T1_slope `1'
loc X_T2_slope `2'


tokenize `years_2_extrapolate'

loc T1_slope `1'
loc T2_slope `2'


tokenize `years'

loc T1 `1'
loc T2 `2'



tempvar slope

gen `gen' =  `X_T1_slope' + (`year' - `T1_slope')*((`X_T2_slope' - `X_T1_slope')/ (`T2_slope'-`T1_slope')) if `year'>=`T1' & `year'<=`T2'

end 











cap program drop path 
program define   path , rclass


syntax

loc C = c(pwd)

di "`C'"


end 




cap program drop pe
program define pe
*Prints and executes lines within a foreach loop. Taken from:http://www.stata.com/statalist/archive/2013-07/msg00116.html

if `"`0'"' != "" { 

display("")

display as text `"`0'"' 

`0'

display("")

}

end



cap program drop dummy_K
program define   dummy_K

syntax, year_born(varlist) year_K(varlist) gen(string) age_T(numlist) age_C(numlist)  [gen_age noisy_type(string)] 

tempvar age_when_K_built year_age_4

gen `age_when_K_built' =   `year_K'-`year_born'

* e.g 7-10
tokenize `age_C'
gen `gen'  = 0 if `age_when_K_built' >=`1' &  `age_when_K_built' <=`2' 

loc UPPER `1'

* e.g 0-3
tokenize `age_T'
replace `gen'  = 1 if `age_when_K_built' >=`1' &  `age_when_K_built' <=`2' 

loc LOWER `2'
gen MIDDLE_`gen' =1 if  `age_when_K_built'>`LOWER' & `age_when_K_built'<`UPPER' & `gen' ==. 


cap drop age_when_K_built_`gen'
if "`gen_age'"!="" gen age_when_K_built_`gen' = `age_when_K_built' 




if "`noisy_type'"=="smooth"  {
replace `gen' = 0.25 if `age_when_K_built'  == 6   
replace `gen' = .    if `age_when_K_built'  == 6 & leave>6 & leave<.
replace `gen' = 0.5  if `age_when_K_built'  == 5   
replace `gen' = 0.75 if `age_when_K_built'  == 4   

}



if "`noisy_type'"=="drop"  {
replace `gen' = .    if `age_when_K_built'  == 6 
replace `gen' = .    if `age_when_K_built'  == 5 
replace `gen' = .    if `age_when_K_built'  == 4 

}



if "`noisy_type'"=="sharp"  {


replace `gen' = 0    if `age_when_K_built'  == 6 
replace `gen' = .    if `age_when_K_built'  == 6 & leave>6 & leave<.
replace `gen' = 0.5  if `age_when_K_built'  == 5   
replace `gen' = 1   if `age_when_K_built'  == 4   




/*


replace `gen' = 0    if `age_when_K_built'  == 6 & `gen' ==0
replace `gen' = .    if `age_when_K_built'  == 6 & leave>6 & leave<.
replace `gen' = 0.5  if `age_when_K_built'  == 5   
replace `gen' = 1   if `age_when_K_built'  == 4   & `gen' ==




*/


}







end 








cap program drop contain
 program define contain, rclass 

syntax anything, word(string)  [lower]



if "`lower'"=="" {

if regexm( "`word'", "`anything'"  )!=1 loc R = "no" 
if regexm( "`word'", "`anything'"  )==1 loc R = "yes" 
}



if "`lower'"!="" {

if regexm( lower("`word'"), lower("`anything'")  )!=1 loc R = "no" 
if regexm( lower("`word'"), lower("`anything'")  )==1  loc R = "yes" 

}



return local contain = "`R'"


end


cap program drop parent_var_K
cap program define parent_var_K

syntax varlist, gen(string) 


egen `gen' =max(`varlist'), by(STRING_IDH)
replace `gen' = . if inlist(RELA, 3,4,5)!=1


end






cap program drop drop_comments 

program define drop_comments 

syntax varlist, parse(string)

tempvar P

gen `P' = strpos(`varlist',"`parse'")

replace  `varlist' = substr(`varlist' , 1 ,`P'-1) if `P' > 0 


end





cap program drop get_number 
prog define get_number 


syntax varlist , gen(string)

gen `gen' = `varlist'

string_clean `gen'
foreach L in q w  e r t y u i o p a s d f  g h  j k l z x c v b n m {


replace `gen' =  subinstr(`gen', "`L'","",10)


}  


real `gen', replace

end



cap program drop get_letters 
prog define get_letters 


syntax varlist , gen(string)

gen `gen' = `varlist'

string_clean `gen'
foreach L in 1 2 3 4 5 6 7 8 9 0 {


replace `gen' =  subinstr(`gen', "`L'","",30)


}  



end



cap program drop freq_by_var 
program define   freq_by_var 


syntax varlist, save(string)   [mean(varlist) first(varlist)] 


preserve


gen ___N =1 


if "`mean'"=="" loc mean_collapse ""
if "`mean'"!="" loc mean_collapse "(mean)`mean'"


if "`first'" ==""  loc first_collapse ""
if "`first'" != "" loc first_collapse "(first) `first'"


sort `varlist'



collapse (sum) ___N   `mean_collapse' `first_collapse', by(`varlist')

sort `varlist'

ren ___N N

loc type =  substr("`save'",-3,3)



if "`type'" ==  "xls"|"`type'" ==  "txt"|"`type'" ==  "csv" outsheet using "`save'", replace
else  save "`save'", replace




restore





end







cap program drop dup 
program define   dup 

syntax, by(varlist)


tempvar one 
gen `one'=1
egen _DupVar= count(`one'), by(`by')


end



cap program drop file_name_state_1910
cap program define file_name_state_1910, rclass

syntax, code(real)


local code_1 "Alabama"
local code_2 "AlaskaTerritory"
local code_4 "Arizona"
local code_5 "Arkansas"
local code_6 "California"
local code_8 "Colorado"
local code_9 "Connecticut"
local code_10 "Delaware"
local code_11 "DistrictOfColumbia"
local code_12 "Florida"
local code_13 "Georgia"
local code_15 "Hawaii"
local code_16 "Idaho"
local code_17 "Illinois"
local code_18 "Indiana"
local code_19 "Iowa"
local code_20 "Kansas"
local code_21 "Kentucky"
local code_22 "Louisiana"
local code_23 "Maine"
local code_24 "Maryland"
local code_25 "Massachusetts"
local code_26 "Michigan"
local code_27 "Minnesota"
local code_28 "Mississippi"
local code_29 "Missouri"
local code_30 "Montana"
local code_31 "Nebraska"
local code_32 "Nevada"
local code_33 "NewHampshire"
local code_34 "NewJersey"
local code_35 "NewMexico"
local code_36 "NewYork"
local code_37 "NorthCarolina"
local code_38 "NorthDakota"
local code_39 "Ohio"
local code_40 "Oklahoma"
local code_41 "Oregon"
local code_42 "Pennsylvania"
local code_44 "RhodeIsland"
local code_45 "SouthCarolina"
local code_46 "SouthDakota"
local code_47 "Tennessee"
local code_48 "Texas"
local code_49 "Utah"
local code_50 "Vermont"
local code_51 "Virginia"
local code_53 "Washington"
local code_54 "WestVirginia"
local code_55 "Wisconsin"
local code_56 "Wyoming"

di "name = `code_`code''"

return local name = "`code_`code''"


end 




cap program drop file_name_state_1900
cap program define file_name_state_1900, rclass

syntax, code(real)


local code_1 "Alabama"
local code_2 "Alaska"
local code_4 "ArizonaTerritory"
local code_5 "Arkansas"
local code_6 "California"
local code_8 "Colorado"
local code_9 "Connecticut"
local code_10 "Delaware"
local code_11 "DistrictOfColumbia"
local code_12 "Florida"
local code_13 "Georgia"
local code_15 "HawaiiTerritory"
local code_16 "Idaho"
local code_17 "Illinois"
local code_18 "Indiana"
local code_19 "Iowa"
local code_20 "Kansas"
local code_21 "Kentucky"
local code_22 "Louisiana"
local code_23 "Maine"
local code_24 "Maryland"
local code_25 "Massachusetts"
local code_26 "Michigan"
local code_27 "Minnesota"
local code_28 "Mississippi"
local code_29 "Missouri"
local code_30 "Montana"
local code_31 "Nebraska"
local code_32 "Nevada"
local code_33 "NewHampshire"
local code_34 "NewJersey"
local code_35 "NewMexico"
local code_36 "NewYork"
local code_37 "NorthCarolina"
local code_38 "NorthDakota"
local code_39 "Ohio"
local code_40 "Oklahoma"
local code_41 "Oregon"
local code_42 "Pennsylvania"
local code_44 "RhodeIsland"
local code_45 "SouthCarolina"
local code_46 "SouthDakota"
local code_47 "Tennessee"
local code_48 "Texas"
local code_49 "Utah"
local code_50 "Vermont"
local code_51 "Virginia"
local code_53 "Washington"
local code_54 "WestVirginia"
local code_55 "Wisconsin"
local code_56 "Wyoming"

di "name = `code_`code''"

return local name = "`code_`code''"


end 


cap program drop file_name_state_1920
cap program define file_name_state_1920, rclass

syntax, code(real)


local code_1 "Alabama"
local code_2 "AlaskaTerritory"
local code_4 "Arizona"
local code_5 "Arkansas"
local code_6 "California"
local code_8 "Colorado"
local code_9 "Connecticut"
local code_10 "Delaware"
local code_11 "DistrictOfColumbia"
local code_12 "Florida"
local code_13 "Georgia"
local code_15 "HawaiiTerritory"
local code_16 "Idaho"
local code_17 "Illinois"
local code_18 "Indiana"
local code_19 "Iowa"
local code_20 "Kansas"
local code_21 "Kentucky"
local code_22 "Louisiana"
local code_23 "Maine"
local code_24 "Maryland"
local code_25 "Massachusetts"
local code_26 "Michigan"
local code_27 "Minnesota"
local code_28 "Mississippi"
local code_29 "Missouri"
local code_30 "Montana"
local code_31 "Nebraska"
local code_32 "Nevada"
local code_33 "NewHampshire"
local code_34 "NewJersey"
local code_35 "NewMexico"
local code_36 "NewYork"
local code_37 "NorthCarolina"
local code_38 "NorthDakota"
local code_39 "Ohio"
local code_40 "Oklahoma"
local code_41 "Oregon"
local code_42 "Pennsylvania"
local code_44 "RhodeIsland"
local code_45 "SouthCarolina"
local code_46 "SouthDakota"
local code_47 "Tennessee"
local code_48 "Texas"
local code_49 "Utah"
local code_50 "Vermont"
local code_51 "Virginia"
local code_53 "Washington"
local code_54 "WestVirginia"
local code_55 "Wisconsin"
local code_56 "Wyoming"

di "name = `code_`code''"

return local name = "`code_`code''"


end 



/*



cap program drop file_name_state_1920
cap program define file_name_state_1920, rclass

syntax, code(real)


local code_1 "Alabama"
local code_2 "Alaska"
local code_4 "Arizona"
local code_5 "Arkansas"
local code_6 "California"
local code_8 "Colorado"
local code_9 "Connecticut"
local code_10 "Delaware"
local code_11 "DistrictOfColumbia"
local code_12 "Florida"
local code_13 "Georgia"
local code_15 "HawaiiTerritory"
local code_16 "Idaho"
local code_17 "Illinois"
local code_18 "Indiana"
local code_19 "Iowa"
local code_20 "Kansas"
local code_21 "Kentucky"
local code_22 "Louisiana"
local code_23 "Maine"
local code_24 "Maryland"
local code_25 "Massachusetts"
local code_26 "Michigan"
local code_27 "Minnesota"
local code_28 "Mississippi"
local code_29 "Missouri"
local code_30 "Montana"
local code_31 "Nebraska"
local code_32 "Nevada"
local code_33 "NewHampshire"
local code_34 "NewJersey"
local code_35 "NewMexico"
local code_36 "NewYork"
local code_37 "NorthCarolina"
local code_38 "NorthDakota"
local code_39 "Ohio"
local code_40 "Oklahoma"
local code_41 "Oregon"
local code_42 "Pennsylvania"
local code_44 "RhodeIsland"
local code_45 "SouthCarolina"
local code_46 "SouthDakota"
local code_47 "Tennessee"
local code_48 "Texas"
local code_49 "Utah"
local code_50 "Vermont"
local code_51 "Virginia"
local code_53 "Washington"
local code_54 "WestVirginia"
local code_55 "Wisconsin"
local code_56 "Wyoming"

di "name = `code_`code''"

return local name = "`code_`code''"


end 



*/



cap program drop file_name_state_1930
cap program define file_name_state_1930, rclass

syntax, code(real)


local code_1 "Alabama"
local code_2 "Alaska"
local code_4 "Arizona"
local code_5 "Arkansas"
local code_6 "California"
local code_8 "Colorado"
local code_9 "Connecticut"
local code_10 "Delaware"
local code_11 "DistrictOfColumbia"
local code_12 "Florida"
local code_13 "Georgia"
local code_15 "HawaiiTerritory"
local code_16 "Idaho"
local code_17 "Illinois"
local code_18 "Indiana"
local code_19 "Iowa"
local code_20 "Kansas"
local code_21 "Kentucky"
local code_22 "Louisiana"
local code_23 "Maine"
local code_24 "Maryland"
local code_25 "Massachusetts"
local code_26 "Michigan"
local code_27 "Minnesota"
local code_28 "Mississippi"
local code_29 "Missouri"
local code_30 "Montana"
local code_31 "Nebraska"
local code_32 "Nevada"
local code_33 "NewHampshire"
local code_34 "NewJersey"
local code_35 "NewMexico"
local code_36 "NewYork"
local code_37 "NorthCarolina"
local code_38 "NorthDakota"
local code_39 "Ohio"
local code_40 "Oklahoma"
local code_41 "Oregon"
local code_42 "Pennsylvania"
local code_44 "RhodeIsland"
local code_45 "SouthCarolina"
local code_46 "SouthDakota"
local code_47 "Tennessee"
local code_48 "Texas"
local code_49 "Utah"
local code_50 "Vermont"
local code_51 "Virginia"
local code_53 "Washington"
local code_54 "WestVirginia"
local code_55 "Wisconsin"
local code_56 "Wyoming"

di "name = `code_`code''"

return local name = "`code_`code''"


end 



cap program drop file_name_state_1940
cap program define file_name_state_1940, rclass

syntax, code(real)

state_name, code(`code')

local name = r(name)

ret local name = "`name'"

end



cap program drop state_name
cap program define state_name, rclass

syntax, code(real)


local code_1    "Alabama"                         
local code_2 	"Alaska"                          
local code_4 	"Arizona"                         
local code_5 	"Arkansas"                        
local code_6 	"California"                      
local code_8 	"Colorado"                        
local code_9 	"Connecticut"                     
local code_10	"Delaware"                        
local code_11	"District of Columbia"            
local code_12	"Florida"                         
local code_13	"Georgia"                         
local code_15	"Hawaii"                          
local code_16	"Idaho"                           
local code_17	"Illinois"                        
local code_18	"Indiana"                         
local code_19	"Iowa"                            
local code_20	"Kansas"                          
local code_21	"Kentucky"                        
local code_22	"Louisiana"                       
local code_23	"Maine"                           
local code_24	"Maryland"                        
local code_25	"Massachusetts"                   
local code_26	"Michigan"                        
local code_27	"Minnesota"                       
local code_28	"Mississippi"                     
local code_29	"Missouri"                        
local code_30	"Montana"                         
local code_31	"Nebraska"                        
local code_32	"Nevada"                          
local code_33	"New Hampshire"                   
local code_34	"New Jersey"                      
local code_35	"New Mexico"                      
local code_36	"New York"                        
local code_37	"North Carolina"                  
local code_38	"North Dakota"                    
local code_39	"Ohio"                            
local code_40	"Oklahoma"                        
local code_41	"Oregon"                          
local code_42	"Pennsylvania"                    
local code_44	"Rhode Island"                    
local code_45	"South Carolina"                  
local code_46	"South Dakota"                    
local code_47	"Tennessee"                       
local code_48	"Texas"                           
local code_49	"Utah"                            
local code_50	"Vermont"                         
local code_51	"Virginia"                        
local code_53	"Washington"                      
local code_54	"West Virginia"                   
local code_55	"Wisconsin"                       
local code_56	"Wyoming"                         




di "name = `code_`code''"

return local name = "`code_`code''"


end 










*use "C:\Users\Francisco\Documents\UCLA\Book_Leah\june_2013\occupations\hisclass50\hisclass50.dta"


cap program drop occ_CAT  
program define  occ_CAT  

syntax varlist, data(string) gen(string) [full]


tempfile before_add

save `before_add' 

use "`data'"

* A few fixes
replace hisclass = 9 if occ50us==290 & hisclass==.
replace hisclass = 12 if occ50us==970 & hisclass==.
replace hisclass = 3 if occ50us==523 & hisclass==.
replace hisclass = 3 if occ50us==290


gen     `gen'_5 = 1 if hisclass==2 | hisclass==3 | hisclass==4 | hisclass==5 | hisclass==6
replace `gen'_5 = 2 if hisclass==7
replace `gen'_5 = 3 if hisclass==8
replace `gen'_5 = 4 if hisclass==9
replace `gen'_5 = 5 if hisclass==10 | hisclass==11 | hisclass==12


if "`full'" != "" {
gen     `gen'_FARMERS = 1 if  occ50us==100
replace `gen'_FARMERS = 2 if  occ50us>=810 & occ50us<=840
replace `gen'_FARMERS = 3 if  `gen'_FARMERS==. & `gen'_5<.

label define `gen'_FARMERS 1 "Farmers (owners)" 2 "Farmers- workers" 3 "Other"


gen     `gen'_OTHER_4 = `gen'_5  if  `gen'_FARMERS ==3


gen `gen'_11 = hisclass
}



gen `varlist' =  occ50us

drop  hisclass  occ50us


sort  `varlist' 
tempfile BIG_OCC

save `BIG_OCC'


use `before_add' 
cap drop _merge
sort  `varlist' 
merge (`varlist' ) using `BIG_OCC'

tab _merge 

drop if _merge ==2


*drop _merge



end









cap program drop desc_occ1950
program define  desc_occ1950

syntax, code(real)

tab occ1950  if occ1950==`code'

end 





cap program drop break_asterisk 

program define break_asterisk, rclass  

syntax anything 


local position = strpos("cas*","*")


local word1 = substr("`anything'", 1, `position'-1 )
local word2 = substr("`anything'", `position'+ 1, . )


ret local word1 = "`word1'"
ret local word2 = "`word2'"


end 









cap program drop 
cap program drop expand_var

program define expand_var

syntax , var(string) var_values(numlist)


count_word_list `var_values'

loc n_rep = r(count)


tempvar id seq 

gen `id' = _n

expand `n_rep'

sort `id'

egen `seq' = seq(), by(`id')

gen `var' = . 



loc  n 0 
foreach x in `var_values' {

loc ++n 

replace `var' = `x' if `seq' ==`n'


}


end 





* separate list with _commas , dots, etc

cap prog drop  separate_list
program define separate_list, rclass 

syntax anything, sep_with(string)

local n = 0 



foreach s in `anything' {


loc ++n 


if `n' ==  1 loc NEWLIST "`s'" 
if `n' !=  1 loc NEWLIST "`NEWLIST'`sep_with' `s'" 


}

return local  new_list = "`NEWLIST'"


end



* Compute centiles 
cap program drop sum_d
program define  sum_d

syntax varlist [if], Delta(real)


centile `varlist' `if', centile(0(`delta')100)

end


cap program drop tab_enu 
program define tab_enu 



syntax anything  [if] [fweight]


tempvar sample

mark `sample' `if'


loc n 0 

foreach x in `anything' {


loc ++n 


if `n'==1 local COND "`x'"
if `n'!=1 local COND "`COND', `x'" 

}



tab enu if `sample' ==1  &  inlist(enu, `COND') [`weight'`exp'] 



end







cap prog drop grab_K_var
prog define grab_K_var 


syntax [if], vars(string) id(string) k_data(string) [add_suffix(string) only_matched detail keep_merge_var keep_all  rename_original(string) rename_new_name(string) ]


sort `id'

tempfile temp_before_K_DATA
save `temp_before_K_DATA'




drop _all

* note: this is NEW========> use `id' `vars' using "`k_data'"

use `id' `vars' using "`k_data'"

tempvar sample
mark `sample' `if' 

keep if `sample'==1

keep `id' `vars'


loc cc 0

if "`rename_new_name'"!=""{
tokenize `rename_new_name'

foreach xx in `rename_original' {

loc ++cc 

cap rename `xx' ``cc''

}

}


if "`add_suffix'"!=""  add_suffix _all, suffix(`add_suffix') exclude(`id') 


sort `id'

merge (`id') using `temp_before_K_DATA'


di _n(10) "!!!!!!!!!!!!!!!!!!!IMPORTANT: !!!!!!!!!!!!!!!!!!!!!!!!!!!" _n(3)
tab _merge 

if "`detail'"!="" bys _merge: tab `id'

di _n(5) "!!!!!!!!!!!!!!!!!!!IMPORTANT: !!!!!!!!!!!!!!!!!!!!!!!!!!!" _n(3)


if "`keep_all'"=="" keep if _merge==2|_merge==3

if "`only_matched'"!= ""  & "`keep_all'"==""  keep if _merge==3



if "`keep_merge_var'"=="" drop _merge

end




cap program drop rsort
program define rsort



syntax 

tempvar r

gen `r' = uniform()

sort `r'



end


cap program drop compare_word_len 
program define compare_word_len , rclass


syntax anything

tokenize `anything'

local l1 =  length("`1'") 
local l2 = length("`2'") 

return scalar L1 = `l1'
return scalar L2 = `l2'

return scalar ratio = `l1'/`l2'



end








cap program drop compare_word_letters 
program define compare_word_letters, rclass


syntax anything

tokenize `anything'



local N =  length("`1'") 
local N2 =  length("`2'") 

loc T =  "`2'"


loc N_success 0 

forvalues i = 1/`N' {


local let = substr("`1'",`i',1)
di "let `i' = `let'"

if regexm("`T'","`let'")==1 {

loc ++N_success  
loc T =  subinstr("`T'","`let'","",1)

}


}




return scalar length_1 = `N'
return scalar length_2 = `N2'

return scalar success_rate = `N_success'/`N'




di in green "success rate = " in yellow (`N_success'/`N')*100 in green " %"


end









cap program drop words_letters_match_rate
program define words_letters_match_rate, rclass


syntax, words_1(string) words_2(string) 



loc n 0 
loc nw 0 
local sum 0
loc sum_max 0 

foreach w1 in `words_1' {

local ++nw 
local nn = 0 

foreach w2 in `words_2' {

local ++nn  

loc ++n 

qui compare_word_letters `w1' `w2'

loc aux = r(success_rate)

local sum =`sum' + `aux'

if `nn' ==1 loc max "`aux'"
if `nn' !=1 loc max "`max', `aux'"

}


if `nn' >1  local max_`nw' = max(`max')
if `nn' ==1 local max_`nw' = `max'

local sum_max = `sum_max' + `max_`nw''

if `nw' ==1 loc aux_abs_max "`max_`nw''"
if `nw' !=1 loc aux_abs_max "`aux_abs_max', `max_`nw''"

}

if `nn' >1  local abs_max = max(`aux_abs_max')
if `nn' ==1 local abs_max = `aux_abs_max'

di in green _n(10)"================================================================================"
di in yellow _n(1) "`words_1'" in white   "   vs.   " in yellow "`words_2'" _n(1)
di in green "================================================================================"
di in green _n(5) "mean success rate = " in yellow  (`sum'/`n')*100 in green " %"
di in green "mean (of max) success rate = " in yellow  (`sum_max'/`nw')*100 in green " %"
di in green "absolute max success rate = " in yellow  `abs_max'*100 in green " %" _n(5)
di in green "================================================================================"


ret scalar mean_success= (`sum'/`n')
ret scalar avg_max     = (`sum_max'/`nw')
ret scalar abs_max     = `abs_max'




end


*words_letters_match_rate,  words_1(hola casa) words_2(casd gola) 



*rank = mean_success ,avg_max ,    abs_max     


cap program drop best_match  
program define best_match  

syntax anything [if], var(varlist) [rank(string) N_matches(numlist) ] 

preserve


if "`n_matches'" =="" loc n_matches 3

if "`rank'" =="" loc rank "avg_max"

tempvar sample 
mark `sample'  `if'

qui keep if `sample'==1


loc N = _N

gen _rank = . 

forvalues n = 1/`N' {

local candidate= `var'[`n']


qui words_letters_match_rate,  words_1(`anything') words_2(`candidate') 


replace _rank = r(`rank')*100 if _n ==`n'


}

gsort -_rank 


list `var' _rank  if _n<= `n_matches'

restore

end











*gen AUX_1_CITY = self_residence_place_city 


cap program drop find
program define find 

syntax anything [if], Look_in(varlist) [list(varlist) long tab(varlist) sum(varlist)]

preserve 

tempvar sample

mark `sample'  `if'

qui keep if `sample'==1



local str_N 20 

if "`long'"!= ""  local str_N 60 


cap decode occ1950, gen(opt_2)


*count_word_list  `anything'



foreach var in `look_in' {

loc n 0 


string `var', replace

foreach x in `anything' {


loc ++n 


if `n'==1 local COND `"regexm( lower(`var'),lower("`x'") )==1"'
if `n'!=1 local COND `"`COND' &  regexm( lower(`var'),lower("`x'") )==1"'


}

di _n(20) in yellow "search in" in red " `var'" in yellow "!"

di  `"list `look_in' `list' if `COND'"'

list `look_in' `list' if `COND' , compress string(`str_N')


if "`tab'"!="" tab `tab'  if `COND', sum(`sum')

}







restore




end








cap program drop city_clean 
program define city_clean  

syntax varlist, [gen(string) split replace]


tempvar AUX_1_CITY AUXCITY 


if "`split'" !="" {

	gen `AUX_1_CITY' = `varlist'

	split `AUX_1_CITY', parse(,)

	cap drop AUXCITY
	
	gen `AUXCITY' =  `AUX_1_CITY'1


	}

else {

gen `AUXCITY' = `varlist'


}


	forvalues i = 1/4 {
	replace `AUXCITY' =subinstr(`AUXCITY', "Ward `i'0","", 2)
	replace `AUXCITY' =subinstr(`AUXCITY', "Precinct `i'0","", 2)
	}



	forvalues i = 10/20 {

	replace `AUXCITY' =subinstr(`AUXCITY', "Ward `i'","", 2)
	replace `AUXCITY' =subinstr(`AUXCITY', "Precinct `i'","", 2)

	}

	forvalues i = 1/9 {

	replace `AUXCITY' =subinstr(`AUXCITY', "Ward `i'","", 2)
	replace `AUXCITY' =subinstr(`AUXCITY', "Precinct `i'","", 2)

	}


	
	forvalues i = 0/9 {

	replace `AUXCITY' =subinstr(`AUXCITY', "`i'","", 10)

	}


	
	replace `AUXCITY'=ltrim(`AUXCITY')
	replace `AUXCITY'=itrim(`AUXCITY')
	replace `AUXCITY'=rtrim(`AUXCITY')



	forvalues i = 1/10 {

	replace `AUXCITY' =subinstr(`AUXCITY', "`i'","", 5)

	}



replace `AUXCITY' =subinstr(`AUXCITY', " Assembly District","", 1)
replace `AUXCITY' =subinstr(`AUXCITY', "Assembly District ","", 1)
replace `AUXCITY' =subinstr(`AUXCITY', "Assembly District","", 1)






if "`gen'" !="" gen `gen' = `AUXCITY'

if "`gen'" ==""  & "`replace'"!=""  {

drop `varlist'
gen `varlist' = `AUXCITY'

}


end 







cap program drop append_all_files
program define append_all_files


syntax, folder(string)  [save(string) type(string) files(string) force_string_format_in(string) gen_file(string)]

if "`type'"=="" loc type "dta"



local C = r(pwd)

di "current dir = `C'"


di "Changing to:"

cd "`folder'"



if "`files'"=="" {

loc files: dir . files "*.`type'"

*di "files = `files'"


}


*di `files' 



* & "`string_format'" ==""


* Tempfiles - DTA
* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if "`type'" == "dta"  {


loc n 0 

foreach f in `files'  {

drop _all

loc ++n 

di _n(10) "tempfile  `f'"

use "`folder'//`f'"

cap gen `gen_file' = "`f'"

tempfile D`n'
save `D`n''



} 

}








* Tempfiles - other format (txt, csv)
* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if "`type'" == "txt" |"`type'" == "csv" {

loc n 0 

foreach f in `files'  {

loc ++n 
drop _all
di _n(10) "tempfile  `f'"

insheet using "`folder'//`f'"

cap gen `gen_file' = "`f'"

tempfile D`n'
save `D`n''


} 
} 





* APPEND 
* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


if "`force_string_format_in'" =="" {

loc n 0 

foreach f in `files'  {

loc ++n 

di _n(10) "appending `f'"

if `n' ==1 qui use `D`n''
else qui append using `D`n''


count

} 


}  // force_string_format_in is empty 


if "`force_string_format_in'" !="" {





loc n 0 

foreach f in `files'  {

loc ++n 

di _n(10) "formating `f'"

use `D`n''

foreach var of varlist `force_string_format_in' {

string `var', replace


}

tempfile D_F_`n'
save `D_F_`n''



}





loc n 0 

foreach f in `files'  {

loc ++n 

di _n(10) "appending `f'"

if `n' ==1 qui use `D_F_`n''
else qui append using `D_F_`n''


count

} 



}  // force_string_format_in is not empty 





if "`save'" !="" save `save', replace


end


* example: append_all_files, folder(/disk/data3/cens1940.work/lplatt/fhaimo/children_matched_1900_1940)



cap program drop string 
program define string 

syntax varlist, [gen(string) replace] 

tempvar STR
cap confirm string variable `varlist'


if _rc {

gen `STR' = string(`varlist')


}

else {

gen `STR' = `varlist'

}



if "`gen'"!="" {

gen `gen' = `STR'

}

if  "`gen'"=="" & "`replace'" !="" {

drop `varlist'
gen `varlist' = `STR'


}


end 




* eg: expand_years, years(1880 1910)

cap program drop expand_years

program define expand_years


syntax , years(numlist)

tokenize `years'

loc n  = `2'-`1' +1

tempvar id seq 

gen `id' = _n

expand `n'

sort `id'

egen `seq' = seq(), by(`id')

gen year = `1' + `seq' -1 



end 




/*
census_region_ipums--> source: 

merge_ipums_vars , years(1920) variables(region statefip) 
levelsof region, local(region_codes)

foreach r in `region_codes' {

qui levelsof statefip if region ==`r', local(states_`r')


separate_list `states_`r'', sep_with(,)

local list = r(new_list)

di "replace X = `r' if inlist(var, `list') ==1 "



}
*/




cap program drop census_region_ipums
program define census_region_ipums

syntax varlist , gen(string)

gen `gen'=. 
replace `gen' = 11 if inlist(`varlist', 9, 23, 25, 33, 44, 50) ==1 
replace `gen' = 12 if inlist(`varlist', 34, 36, 42) ==1 
replace `gen' = 21 if inlist(`varlist', 17, 18, 26, 39, 55) ==1 
replace `gen' = 22 if inlist(`varlist', 19, 20, 27, 29, 31, 38, 46) ==1 
replace `gen' = 31 if inlist(`varlist', 10, 11, 12, 13, 24, 37, 45, 51, 54) ==1 
replace `gen' = 32 if inlist(`varlist', 1, 21, 28, 47) ==1 
replace `gen' = 33 if inlist(`varlist', 5, 22, 40, 48) ==1 
replace `gen' = 41 if inlist(`varlist', 4, 8, 16, 30, 32, 35, 49, 56) ==1 
replace `gen' = 42 if inlist(`varlist', 2, 6, 15, 41, 53) ==1 


cap label drop _`gen'

label define  _`gen'      11  "New England Division" 12  "Middle Atlantic Division" 21  "East North Central Div." 22  "West North Central Div." 31  "South Atlantic Division" 32  "East South Central Div." 33  "West South Central Div." 41  "Mountain Division" 42  "Pacific Division"

label values `gen' _`gen'      

end





* SOuth region

cap program drop south_ipums 

program define south_ipums 

syntax varlist [if], gen(string)   [string]



tempvar sample

mark `sample'  `if'

if "`string'"!= ""  {

gen `gen' = 0  if `sample'==1  & `varlist'!=""
replace `gen'=1 if lower(`varlist')=="alabama"  & `sample'==1
replace `gen'=1 if lower(`varlist')=="arkansas" & `sample'==1
replace `gen'=1 if lower(`varlist')=="florida"   & `sample'==1
replace `gen'=1 if lower(`varlist')=="georgia"   & `sample'==1
replace `gen'=1 if lower(`varlist')=="kentucky"   & `sample'==1
replace `gen'=1 if lower(`varlist')=="louisiana"  & `sample'==1
replace `gen'=1 if lower(`varlist')=="mississippi"  & `sample'==1
replace `gen'=1 if lower(`varlist')=="north carolina"  & `sample'==1
replace `gen'=1 if lower(`varlist')=="oklahoma" & `sample'==1
replace `gen'=1 if lower(`varlist')=="south carolina" & `sample'==1
replace `gen'=1 if lower(`varlist')=="tennessee" & `sample'==1
replace `gen'=1 if lower(`varlist')=="texas" & `sample'==1
replace `gen'=1 if lower(`varlist')=="virginia" & `sample'==1
replace `gen'=1 if lower(`varlist')=="west virginia" & `sample'==1



}


else {

gen `gen' = (`varlist' ==12|`varlist' ==13|       `varlist' ==37|`varlist' ==45|`varlist' ==51|`varlist' ==54|`varlist' ==1|`varlist' ==21|`varlist' ==28|`varlist' ==47|`varlist' ==5|`varlist' ==22|`varlist' ==40|`varlist' ==48)  if `varlist'<. & `varlist'<57 & `sample'==1





}


end






cap program drop match 
prog define match 

syntax  anything , [look_in(varlist) list(varlist) long]

if "`look_in'" == ""  loc look_in "occstr opt_2" 
if "`list'" == "" loc list "occstr occscore_mode opt_2" 

local str_N 20 

if "`long'"!= ""  local str_N 60 


cap decode occ1950, gen(opt_2)


*count_word_list  `anything'



foreach var in `look_in' {

loc n 0 

foreach x in `anything' {


loc ++n 


if `n'==1 local COND `"regexm( lower(`var'),lower("`x'") )==1"'
if `n'!=1 local COND `"`COND' &  regexm( lower(`var'),lower("`x'") )==1"'


}

di _n(20) in yellow "search in" in red " `var'" in yellow "!"

di  `"list `list' if `COND'"'

list `list' if `COND' , compress string(`str_N')

}

end 


* match Carpenter apprentice, var(occstr) list(occstr occscore_mode) 





cap program drop merge_data

program define merge_data

syntax [if], by(string) data_1(string) data_2(string)  [add_suffix_1(string)  add_suffix_2(string)  save(string) keep_1(string) keep_2(string)  keep_if(string) ]


cap drop _all


foreach d in 1 2   {

use `data_`d'' `if' 



if "`add_suffix_`d''" != "" {

if "`keep_`d''" != "" keep `by' `keep_`d''

add_suffix _all, suffix(`add_suffix_`d'') exclude(`by') 


}

sort `by'

tempfile temp`d'
save `temp`d''


}


use `temp1'

sort `by'

merge (`by') using `temp2'

tab _merge 


if "`keep_if'" != "" keep if `keep_if'


drop _merge


if "`save'" != ""  save "`save'", replace



end




* connect ESTIMATED_ENR year if st=="NY", id(city)

* legend(on|off)

cap program drop connect
program define connect



syntax varlist [if], id(varlist)  [legend(string)  scheme(string) ylabel(string) xlabel(string) title(string) subtitle(string) rows(numlist)  save(string)  xline(numlist)]




local options ""



tempvar sample
mark `sample'  `if'


tokenize `varlist'


levelsof `id' if `sample' == 1 , local(list)


local n 0 

foreach x in `list'  {


loc ++n 

capture confirm string variable `id'

if _rc {

local graphs "`graphs'  (connect `varlist' if `id' ==`x' & `sample' == 1 , sort )"


}


if !_rc {

local graphs `"`graphs'  (connect `varlist' if `id' =="`x'" & `sample' == 1  , sort )"'


}



local lab ""

cap label_value , labelvar( `id') value(`x')

if !_rc loc lab= r(label)
if  _rc loc lab "`x'"

local order `"`order' `n' "`lab'" "'



}



local show_legend "legend(off)"

if "`legend'"=="on" local show_legend "legend(order(`order') rows(`rows') region(fcolor(none) lcolor(none))  )"



di `"twoway `graphs' , `show_legend'"'
twoway `graphs' , `show_legend' plotregion(lcolor(none)) scheme(`scheme') /*graphr(m(zero))*/  ylabel(`ylabel')  xlabel(`xlabel') title(`title') subtitle(`subtitle')  xline(`xline')



if "`save'" != ""  gr export "`save'", replace



*legend(order(`order') region(fcolor(none) lcolor(none))) /*position(12)*/ title("`title'")  subtitle("`subtitle'") graphr(m(zero))


end







* Particion regression

cap program drop part_reg_graph
program define part_reg_graph


syntax varlist [if] [aweight], rest_X(varlist)    [xtitle(string) ytitle(string) title(string) subtitle(string) ]

preserve

local n 0 

foreach var in `varlist' {

loc ++n

if `n'==1 loc Y `var'
if `n'!=1 loc X `var'

}


regress `Y' `rest_X' `if' [`weight'`exp'] 
tempvar e_y
predict `e_y' `if', resid
predict e_y `if', resid



regress `X' `rest_X' `if' [`weight'`exp'] 
tempvar e_x
predict `e_x' `if', resid
predict e_x `if', resid


twoway (scatter `e_y'  `e_x')  (lfit `e_y'  `e_x')  ,  legend(off) scheme(s1mono) plotregion(lcolor(none)) title("`title'")  subtitle("`subtitle'") graphr(m(zero)) xtitle("`xtitle'")  ytitle("`ytitle'") xscale(titlegap(1) outergap(0)) 

regress `e_y'  `e_x' `if' [`weight'`exp'] 
restore


end








cap program drop real

program define real

syntax varlist,  [gen(string) replace]

tempvar temp
gen `temp' = subinstr( `varlist',"%","",10)
replace  `temp'= subinstr( `temp',",","",10)

if "`gen'"!= "" gen double `gen' = real(`temp')
if "`replace'"!= "" {

drop `varlist'
gen `varlist' = real(`temp')


}
end








cap prog drop graph_IC

prog define graph_IC, rclass

syntax varlist, mat(string)  Confidence(real) [ name(string)labels(string) xtitle(string) ylabel(string) xlabel(string)  ] 

  
count_list `varlist'


loc N = r(count)

mat `mat' = J(`N',3,.)


local row 0 

if "`labels'" != "" tokenize `labels'


foreach x in `varlist'   {



if "`labels'" != "" loc label_list `" `label_list' `row' "``row''" "'

local ++row  



IC `x', df(e(df_r)) confidence(`confidence')


mat `mat'[`row',1] = r(lower) 
mat `mat'[`row',2] = r(middle)
mat `mat'[`row',3] = r(upper) 



}

mat colnames `mat' = lower middle upper 

mat list `mat'

preserve

drop _all
svmat `mat', names(col) 

gen x = _n


if "`labels'" != "" label define x  `label_list'
if "`labels'" != "" label values x  x


tab x

twoway (line lower x, sort lwidth(vvvthin) lpattern(shortdash_dot)) (connected middle x, sort lpattern(dash)) (line upper x, lwidth(medthin) lpattern(shortdash_dot)), yline(0, lwidth(vvvthin) lpattern(solid) lcolor(gray)) xlabel(1(1)`N', valuelabel) xmtick(1(1)17, nolabels ticks) scheme(s1mono) plotregion(lcolor(none))  legend(off)  plotregion(lcolor(none)) xtitle(`xtitle') ylabel(`ylabel') xlabel(`xlabel') title("`name'")






restore



end


*graph_IC  IxA_* ,  mat(A) confidence(95) labels(0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16)




cap program drop labels_to_x
program define labels_to_x

syntax varlist, save(string) [blank add_var_name] 

preserve


loc keep_var_name 0 

if "`add_var_name'"!=""  loc keep_var_name 1 
if "`add_var_name'"!=""  loc keep AUX___var_names




gen labels = ""
if `keep_var_name'== 1 gen AUX___var_names = ""  


loc n 0 
foreach x in `varlist' {

loc ++n 

loc lab`x' : var label  `x'

replace labels = "`lab`x''" if _n == `n'
if `keep_var_name'== 1 replace AUX___var_names = "`x'" if _n == `n'

if "`blank'"!="" loc ++n 

}

gen id = _n

keep if id <=`n'

keep label id `keep'



loc type =  substr("`save'",-3,3)



if "`type'" ==  "xls"|"`type'" ==  "txt"|"`type'" ==  "csv" outsheet using "`save'", replace
else  save "`save'", replace

restore
end









* mycodebook

cap program drop mycodebook 
program define mycodebook 


syntax varlist, save(string)

count_word_list  `varlist'

local rows = r(count)


tempname mat 

mat `mat' = J(`rows', 7,.)


loc r 0 
foreach var in `varlist' {


loc ++r 


cap confirm numeric  variable `var'

if !_rc {

qui sum `var', d

mat `mat'[`r',1] = r(N)
mat `mat'[`r',2] = r(mean)
mat `mat'[`r',3] = r(p50)
mat `mat'[`r',4] = r(p5)
mat `mat'[`r',5] = r(p95)
mat `mat'[`r',6] = r(min)
mat `mat'[`r',7] = r(max)



}


if _rc {


count if `var' != "" 
mat `mat'[`r',1] = r(N)



}





} 

mat colnames `mat' = Obs    mean  median   percentile_5    percentile_95   min_value   max_value   


tempfile temp

labels_to_x `varlist', save(`temp') add_var_name 



preserve


drop _all

use `temp'

sort id 

save, replace


drop _all

svmat `mat', names(col)

gen id = _n 

gen VARIABLE_NAME = ""

loc n 0 

foreach var in `varlist'  {

loc ++n 

replace VARIABLE_NAME = "`var'" if _n==`n'

}


sort id 

merge (id) using `temp'


tab _merge








keep VARIABLE_NAME labels Obs    mean  median   percentile_5    percentile_95   min_value   max_value

order VARIABLE_NAME labels Obs    mean  median   percentile_5    percentile_95   min_value   max_value


outsheet _all  using "`save'", replace



restore 

end




* Graph mat: X, first col, rest = `y'

* graph_mat A, save(blaaaaaaa) x(year)

cap prog drop graph_mat  
prog define graph_mat 


syntax anything, save(string)  x(string) [title(string) list(string) ylabel(string)]

preserve 

drop _all

svmat `anything', names(col) 






local included "_all"

if "`list'" != "" loc included "`list'"


foreach var of varlist `included'{


if "`var'"!="`x'"  {


loc graph "`graph' (connected `var' `x') "


}



}


twoway `graph'  , scheme(s1mono) plotregion(lcolor(none))  title("`title'") subtitle("`subtitle'") legend(order(`order') region(fcolor(none) lcolor(none))) graphr(m(zero))  ylabel("`ylabel'")

restore

end 





* Allows by
cap program drop mytab2 

program define mytab2



syntax varlist [if] [aweight], mat(string) [sum(varlist) stat(string) by(varlist)]



tempvar sample 
mark `sample' `if'


if "`by'"!=""  {

qui levelsof `by' `if', local(by_values) 

tempname x_rows 
qui mytab `varlist' if `sample'==1 [`weight'`exp']  , mat(`x_rows') sum(`varlist') stat(`stat') 

mat `mat' = `x_rows'



local n 0 
foreach b in `by_values'  {


di "`by' = `b'"

loc ++n 


tempname mat`b'

qui mytab `varlist' if `sample'==1 & `by' ==`b' [`weight'`exp']  , mat(`mat`b'') sum(`sum') stat(`stat') 

mat `mat' = `mat', `mat`b'' 


local colnames "`colnames' `by'_`b'"

}





mat colnames `mat' = `varlist' `colnames'
}




else {


mytab `varlist' `if' [`weight'`exp'] , mat(`mat') sum(`sum') stat(`stat') 


}



end






* Vecotrs!!!!!!!!!!!!!!!!!!


* Default: percentage (VECTOR)
* Defalt sum(varlist): mean
cap program drop mytab 

program define mytab



syntax varlist [if] [aweight], mat(string) [sum(varlist) stat(string)]




tempvar sample

mark `sample' `if'

qui tab `varlist'

local R = r(r)

mat `mat' = J(`R',1,.)



tempvar one 
qui gen `one' = 1 




levelsof `varlist' , local(values)


qui sum `one' [`weight'`exp'] if `varlist' != . & `sample' ==1   

local N = r(sum)





local Y `one'

if "`sum'" != "" {

loc report_stat mean

if "`stat'" !=""  loc report_stat `stat'

loc Y `sum'



}





local row 0 

foreach v in `values'  {

local ++row  

qui sum `Y' [`weight'`exp'] if `varlist' != . & `sample' ==1  & `varlist' ==`v', d

if "`report_stat'"=="" mat `mat'[`row',1]=r(sum)/`N'
if "`report_stat'"!="" mat `mat'[`row',1]=r(`report_stat')

}








mat list `mat'


end







cap program drop abbrev_string_list
program define abbrev_string_list, rclass


syntax, string(string) n(real)

*di `"`string'"' 

local string = subinstr(`"`string'"', `"""',"",10)


if 1 ==2 {

"

}


clean_local_string, string(`"`string'"' )



loc aux = r(string)


foreach S in `aux'  {




local red_string= substr("`S'",1,`n')


local abbrev_string =  "`abbrev_string' `red_string'"

}

*di `"`abbrev_string'"' 

ret local abbrev_string = `"`abbrev_string'"'

end

* abbrev_string_list, string(? DISTRICT MGR) n(4)
*



cap program drop clean_local_string
program define clean_local_string, rclass

syntax, string(string) [drop_s drop(string)]


if "`drop'" != "" loc add `"drop"'

foreach S in "[" "!"  "{" "?" "}" "[" "]"  "(" ")"  ":"  "-"  "\"  "/"  "." `add'{

local string = subinstr("`string'", "`S'"," ",10)

*di "`string_`i''"

}


ret local string = "`string'"


end 




cap program drop qkdensity

prog define qkdensity


syntax [varlist] [if], [legend_list(string) use_labels title(string) subtitle(string) leahs_format xtitle(string) G1_graph(string)  G2_graph(string)  G3_graph(string) save(string) ] 


local options_leahs_format "scheme(s1mono) plotregion(lcolor(none))"




if "`leahs_format'" =="" loc options_graph "scheme(s2mono)"
if "`leahs_format'" !="" loc options_graph "`options_leahs_format'"


cap drop  ____K*

tempvar sample

mark `sample' `if'

forvalues gg = 1/3 {


if "`g`gg'_graph'" != "" {

 if `gg'==1 loc varlist ""

tempvar X`gg'

di _n(10)	"gen `X`gg'' = `g`gg'_graph'  & `sample'==1" _n(10)


gen `X`gg'' = `g`gg'_graph'  & `sample'==1


label var `X`gg''  "`g`gg'_graph'"
loc varlist "`varlist' `X`gg''"



di "varlist = `varlist'"


}


}




loc ms_1 "O"
loc ms_2 "s"

loc lpattern_1 solid
loc lpattern_2 dash
loc lpattern_3 dot








*local list_X  "`varlist'"  




local ng 0 


foreach x in `varlist'  {

loc ++ng




kdensity `x' `if'  , gen (____KDx`x' ____KDD`x' ) 

local graph "`graph' (line ____KDD`x' ____KDx`x' ,  ms(`ms_`ng'') lwidth(thin) lpattern(`lpattern_`ng'') lcolor(black))  "


}


local n 0 

foreach lab in `legend_list' {

local ++n  

loc order "`order' `n' `"`lab'"'"


}


if "`use_labels'"!= ""{

local n 0 

loc order "" 

foreach var in `varlist' {

local ++n  

loc lab: var label `var' 

loc order "`order' `n' `"`lab'"'"


}

}






* template 1
twoway `graph', `options_graph' legend(order(`order') region(fcolor(none) lcolor(none))) /*position(12)*/ title("`title'")  subtitle("`subtitle'") graphr(m(zero)) xtitle("`xtitle'") xscale(titlegap(1) outergap(0))




if "`save'" != ""  graph export  "`save'", replace






drop ____KD*

end 


cap program drop qgraph

prog define qgraph 


syntax varlist [if], [add_45] 


tokenize `varlist'

if "`add_45'"==""  twoway (scatter `varlist' `if'), scheme(s2mono)
if "`add_45'"!=""  twoway (scatter `varlist') (line `1' `1') , scheme(s2mono) legend(off)




end 






cap program drop dissimilarity_index 
prog define dissimilarity_index, rclass

syntax [if], share_city_black(varlist)  share_city_white(varlist) 

tempvar DIF
gen `DIF' = abs(`share_city_black'-`share_city_white') `if'

sum `DIF'  `if'

ret list 

ret scalar dissimilarity_index= r(sum)/2


di in green _n(30)  "====================="

di in yellow "dissimilarity index= " r(sum)/2

di in green "====================="

end







cap program drop check_if_inlist 
program define check_if_inlist , rclass

syntax anything , list(string)


local in_list 0 


foreach x in `list'  {


if "`anything'" =="`x'" {

local in_list 1

}


}


di in green "in list = " in yellow `in_list'
ret scalar in_list = `in_list'



end 


* check_if_inlist a , list(a b c )



cap program drop add_suffix
program define add_suffix


syntax varlist, suffix(string) exclude(varlist) 


foreach var in `varlist' {


 check_if_inlist `var' , list(`exclude' )

if  r(in_list)!=1 ren `var' `var'_`suffix'


}


end 




cap program drop change_suffix
program define change_suffix


syntax varlist, old_suffix(string) new_suffix(string) 


foreach var in `varlist' {



local new_name = regexr( "`var'","`old_suffix'","`new_suffix'")

ren `var' `new_name'


}


end 




* add_suffix _all , suffix(1970) exclude( metaread) 



cap program drop string_clean_K_project
program define string_clean_K_project

syntax varlist 


string_clean `varlist'


replace `varlist' =subinstr(`varlist', "saint","st", 2)





end







cap program drop string_clean
program define string_clean

syntax varlist 


replace `varlist'=ltrim(`varlist')
replace `varlist'=itrim(`varlist')
replace `varlist'=lower(`varlist')
replace `varlist'=rtrim(`varlist')
replace `varlist' = subinstr(`varlist'," ","",10)
replace `varlist' = subinstr(`varlist',"-","",10)

end 



cap program drop string_clean_II
program define string_clean_II

syntax varlist 


*replace `varlist'=ltrim(`varlist')
*replace `varlist'=itrim(`varlist')
replace `varlist'=lower(`varlist')
*replace `varlist' = subinstr(`varlist'," ","",10)
replace `varlist' = subinstr(`varlist',"-","",10)
replace `varlist' = subinstr(`varlist',":","",10)



foreach S in "[" "!"  "{" "?" "}" "[" "]"  "(" ")"  ":" "," "." {

replace `varlist' = subinstr(`varlist', "`S'","",10)

*di "`string_`i''"

}


end 




cap program drop vars_in_beta 

program define vars_in_beta , rclass
syntax, local(string)


tempname A
mat `A' = e(b)
loc colnames: colnames `A'


di in yellow _n(20) "colnames: " in red "`colnames'" 


*loc variables = subinword(`"`colnames'"',"_cons","",1) 


foreach x in `colnames' {

if "`x'"!= "_cons"  loc variables "`variables' `x'"

}



di _n(100)  in red "variables: " in yellow "`variables' " _n(100)



ret local `local'  "`variables'"



end 









cap program drop break_local 

program define break_local, rclass 


syntax anything, n(real)


* count_word_list  `anything' 

* local N = r(count)

local G 1 
local count 0 

foreach x in `anything'  {

local ++count  



if `count' >`n' {

local count 1 
local ++G  


} 



local local_`G' "`local_`G'' `x'"

ret local local_`G'  = "`local_`G''"



}


ret scalar N_groups = `G'


end







cap program drop dummy_if_inlist
program define dummy_if_inlist

syntax varlist, values(numlist) gen(string)


local c 0 
foreach x in `values' {

local ++c 


if `c'==1 local list "`x'"
if `c'!=1 local list "`list', `x'"





} 


gen `gen'= inlist(`varlist',`list')



end

* example: dummy_if_inlist county_id_1940 , values(`macro_1940_counties') gen(dummy_1940_county)







cap prog drop mat_combine

prog define mat_combine

syntax anything , blank_size(numlist) mat(string) [long note(string)] 

loc n 0 
foreach m in `anything'  {


loc ++n

local N_rows = rowsof(`m')
local N_cols = colsof(`m')



* long
if "`long'"!="" {


di _n   _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  in yellow "`note'" in green "    LONG    "

tempname blank
if `blank_size'>0 mat `blank'=J(`blank_size',`N_cols',.)

if `n'==1 mat `mat'=`m' 
if `n'!=1 & `blank_size'>0  mat `mat'=`mat'\\`blank'\\`m'
if `n'!=1 & `blank_size'==0  mat `mat'=`mat'\\`m'


}

if "`long'"=="" {

di _n   _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  _n  in yellow "`note'" in green "    WIDE    "


tempname blank
if `blank_size'>0 mat `blank'=J(`N_rows',`blank_size',.)




if `n'==1 mat `mat'=`m' 
if `n'!=1 & `blank_size'>0  mat `mat'=`mat',`blank',`m'
if `n'!=1 & `blank_size'==0  mat `mat'=`mat',`m'


}


}

mat list `mat'

end



















cap prog drop weighted_average 
prog define  weighted_average, rclass



syntax varlist [if], weight(varlist)

tempvar sample W WxX

mark `sample' `if' 


qui sum `weight' `if' 

gen `W' = `weight'/r(sum) `if' 


qui sum `W' 
if r(sum)>1.02 |r(sum)<.98 {


di in red   "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!error: weights don't add to 1"


di in green "they add to " in yellow r(sum)


*error 8 

}    



qui gen `WxX' = `varlist'*`W' `if' 


qui sum `WxX'



ret scalar weighted_avg = r(sum)








end















cap prog drop standar

prog define standar

syntax varlist [if] [aweight] 


tempvar sirve

mark `sirve' `if' 

foreach x in `varlist' {


	qui count if `x'==. 
	di "`x': # obs before " r(N)
	
qui 	sum `x'[`weight'`exp']  if `sirve' ==1

qui	replace `x' = (`x'-r(mean))/r(sd) if `sirve' ==1


	qui count if `x'==. 
	di "`x': # obs after" r(N) _n(10)


}



end


cap prog drop stat_BY_var

prog define stat_BY_var

syntax varlist (max=1) [if] [fweight], rows_m(varlist) stat(string) mat(string) [number_of_row_blanks(numlist) number_of_col_blanks(numlist) cols_m(varlist) transpose all_rows_stat times_100 codes_if_sample] 



tempvar all

if "`cols_m'"==""  loc cols_m `all'

gen `all'=1


count_word_list `rows_m' 

loc N = r(count)

count_word_list `cols_m' 

loc N2 = r(count)



foreach y in `cols_m' {

tempname `y'

local list ""

foreach x in `rows_m' {

tempname `x'

di _n  " y=`y', x=`x' "_n 

qui AUX2_stat_BY_var `varlist' `if' [`weight'`exp'], rows_m(`x') stat(`stat') mat(``x'') cols_m(`y') `transpose' `all_rows_stat' `times_100'  `codes_if_sample'

loc list "`list' ``x''"

}  // close x


if `N'>1  mat_combine `list' , blank_size(`number_of_row_blanks') mat(``y'') long note("first mat combine")
if `N'==1  mat ``y''=`list'

local list2 "`list2' ``y'' "

} //close y



if `N2'>1  mat_combine `list2' , blank_size(`number_of_col_blanks') mat(`mat') 
if `N2'==1  mat `mat'=`list2'


end





cap prog drop AUX2_stat_BY_var

prog define AUX2_stat_BY_var

syntax varlist (max=1) [if] [fweight], rows_m(varlist) stat(string) mat(string) [cols_m(varlist) transpose all_rows_stat times_100 codes_if_sample] 


AUX_stat_BY_var `varlist' `if' [`weight'`exp'], rows_m(`rows_m') stat(`stat') mat(`mat') cols_m(`cols_m') `transpose' `times_100' `codes_if_sample'

if "`all_rows_stat'" != "" {

tempvar AUX_

gen `AUX_' = 1 


tempname AUXMAT
AUX_stat_BY_var `varlist' `if' [`weight'`exp'], rows_m(`AUX_') stat(`stat') mat(`AUXMAT') cols_m(`cols_m') `transpose' `times_100'


mat `mat'= `AUXMAT'\\`mat'

}


end


* =============================================================================================================* 


cap prog drop AUX_stat_BY_var

prog define AUX_stat_BY_var

syntax varlist (max=1) [if] [fweight], rows_m(varlist) stat(string) mat(string) [cols_m(varlist) transpose times_100   codes_if_sample] 




* 

* temp names
tempname A B


* Observations used 
tempvar sample all
gen `all' = 1


* =1 if `if'
mark `sample' `if' 



* (cols)

if "`cols_m'"==""  loc cols_m = "`all'" 



* groups

di "groups= `cols_m'" _n 





if "`codes_if_sample'"!="" qui tab `cols_m' if `sample'==1, matrow(`B')
if "`codes_if_sample'"=="" qui tab `cols_m'	        , matrow(`B')



loc N_cols = rowsof(`B')



* mat with the values of `rows_m' 
if "`codes_if_sample'"!=""  qui tab `rows_m' if `sample'==1, matrow(`A') 
if "`codes_if_sample'"==""  qui tab `rows_m'               , matrow(`A') 

* % of rows 

loc N_rows = rowsof(`A')


* matrix to store results 
mat `mat' = J(`N_rows',`N_cols',.) 

mat list `mat'

* fill the matrix 
forvalues r = 1/`N_rows' {

forvalues c = 1/`N_cols' {

qui sum `varlist' [`weight'`exp'] if `rows_m'==`A'[`r',1] & `cols_m'== `B'[`c',1] &  `sample'==1  , d


mat `mat'[`r', `c'] = r(`stat')
if "`times_100'" != "" mat `mat'[`r', `c'] = r(`stat')*100




}
}

mat list `mat'


if "`transpose'"!="" mat `mat'=`mat''

end 









cap program drop make_folder 
program define make_folder 


syntax anything
 
 
 local current_path =c(pwd)

*di subinstr("`anything'","\"," ",.)
loc path=  subinstr("`anything'","\"," ",.)

di "`path'"


count_word_list `path'

loc N= r(count)

loc n  0 

foreach x in `path'  {


loc ++n  


di "`x'"

cap  cd "`x'\"

if _rc {

mkdir `x' 
cd "`x'\"
}

}


cd "`current_path'"

end




* match obs: example motherloc vs id 



cap program drop match_members 
program define match_members

syntax, name(string) gral_id(varlist) your_id(varlist) member_id(varlist) sample_you_used(string) sample_members_used(string) x(varlist)  [reshape_j(varlist)]



tempfile base_data

save `base_data'
count 
di in yellow _n(30) "original numer of observations: " in red r(N) _n(10)




keep if (`sample_you_used')


loc n 0 
foreach var in `your_id' {

loc ++n 

gen ___id_`n'= `var'  

loc sort "`sort' ___id_`n'"

}




tempfile temp1 


di "sort = `sort'" 

keep `sort' `gral_id'

sort `sort'

* save
save `temp1'



* X matched 

use `base_data'


keep if (`sample_members_used')




keep `member_id' `x'  `reshape_j'


foreach var in `x' {


rename `var' `name'_`var'

}



if "`reshape_j'"!=""  {


sort `member_id' `reshape_j'


reshape wide `name'_*, i(`member_id') j(`reshape_j')


}



loc n 0 
foreach var in `member_id' {

loc ++n 

gen ___id_`n'= `var'


}



drop `member_id' 


sort `sort'

tempfile temp2

save `temp2'


use `temp1' 

merge (`sort') using `temp2' 

tab _merge

keep if _merge==3

drop _merge




drop `sort'


tempfile temp3

sort `gral_id'

save `temp3'


use `base_data'

sort `gral_id'

merge (`gral_id') using `temp3'

tab _merge

drop _merge






end







cap prog drop scalar_mean

prog define scalar_mean, rclass


syntax anything 

loc sum 0 
loc N = 0
foreach x in `anything' {

loc ++N
loc sum = `sum' + `x'


}


ret scalar scalar_mean= `sum'/`N'



end 



cap prog drop break_data

prog define break_data

syntax anything [if], save(string) [path(string)] raw(string)

drop _all
use "`raw'" 


tempvar sample

mark `sample' `if' 



tempname A
tab `anything' if `sample'==1, matrow(`A')
local rows = r(r)


forvalues r = 1 / `rows'  {

drop _all

use `raw'

tempvar sample

mark `sample' `if' 




keep if `sample'==1 & `anything'==`A'[`r',1]

local name = `A'[`r',1]

save "`path'`save'_`name'.dta", replace


}




end 




cap prog drop break_data2

prog define break_data2

syntax anything [if], save(string) [path(string)] raw(string)

drop _all
use "`raw'" 

levelsof `anything', local(Xs)


foreach x in `Xs' {


drop _all

use `raw'

tempvar sample

mark `sample' `if' 




cap keep if `sample'==1 & `anything'=="`x'"
cap keep if `sample'==1 & `anything'==`x'



save "`path'`save'_`x'.dta", replace


}




end 





cap prog drop table_2stats_BY

prog define table_2stats_BY

syntax anything [if] [fweight], by(varlist) stat1(string) stat2(string) mat(string) [path(string) n_positive_weight] 




* weight var
local wt : word 2 of `exp'

* Observations employed 
tempvar sample

* =1 if `sample'
mark `sample' `if' 

tempname A

qui tab `by', matrow(`A') 

* mat list `A'

loc cols  = r(r)

count_word_list `anything'

mat `mat'= J(r(count)*3 + 1,`cols',.)
mat `mat'_OBS= J(r(count)*3 + 1,`cols',.)


loc row 0 

foreach var of varlist `anything' {

loc ++row  


forvalues c = 1/`cols' {



di "var `var' , `by' " `A'[`c',1]

*di "sum `var' [`weight'`exp'] if `by'==`A'[`c',1] & `sample'==1"
sum `var' [`weight'`exp'] if `by'==`A'[`c',1] & `sample'==1
mat `mat'[`row', `c']=r(`stat1')
mat `mat'[`row'+1, `c']=r(`stat2')

* obs 


if "`n_positive_weight'"==""  qui sum `var' if `by'==`A'[`c',1] & `sample'==1
if "`n_positive_weight'"!=""  qui sum `var' if `by'==`A'[`c',1] & `sample'==1 & `wt'>0
mat `mat'_OBS[`row', `c']=r(N)




}

loc ++row
loc ++row

}  //anything


export_mat `mat', save(`path'`mat'.xls) 
export_mat `mat'_OBS, save(`path'`mat'_OBS.xls) 
 

end 























* program: intervals of confidence  
* example IC pric , df(e(df_r)) confidence(95)
cap prog drop IC

prog define IC, rclass

syntax anything, df(string) confidence(real) 
  

local p_tail = (100-`confidence')/(2*100)

*e(df_r)
local lb =  _b[`anything'] - invttail(`df',`p_tail') * _se[`anything']
local ub =  _b[`anything'] + invttail(`df',`p_tail') * _se[`anything']


ret scalar lower =`lb'

loc mm = _b[`anything']

ret scalar middle =`mm'

ret scalar upper =`ub'
end





cap prog drop find_age
prog define find_age, rclass

syntax anything



loc aux = subinstr("`anything'","_age_","$",1)
loc p = strpos("`aux'","$") 

loc auxage = substr("`aux'",`p'+1,.)

di "`auxage'"

loc ages = subinstr("`auxage'","_"," ",1)
di "`ages'"

ret local ages ="`ages'"



end



cap program drop expand_name 
prog define expand_name, rclass 


syntax anything, min(real) max(real) int(real)

forvalues i = `min'(`int')`max' {


local names "`names' `anything'_`i'" 


}


return local names ="`names'"


end


expand_name BPI  , min(5) int(2) max(9) 




cap prog drop FILL_numb 

prog define FILL_numb , rclass



syntax anything

tokenize `anything'

loc min `1'
loc max `2'


forvalues i = `min'/`max' {

local numbers "`numbers' `i'"

}


ret local numbers ="`numbers'"


end




cap prog drop sep_string

prog define sep_string, rclass



syntax , string_orig(string) sep(string) 

loc p = strpos("`string_orig'","`sep'") 
loc N = strlen("`string_orig'")


local first = substr("`string_orig'",1,`p'-1) 
local second = substr("`string_orig'",`p'+1,`N') 

ret local first ="`first'"
ret local second ="`second'"

end


/*


mat A = [1, 2, 3\ 3,2,1\9,8,7]

mat colnames A = A B C
mat rownames A = A B C

*/


cap prog drop DIAGONAL 
prog define DIAGONAL 


syntax anything, mat_new(string) 

local M `anything'
local N = colsof(`M')


loc names : colnames `M'


mat `mat_new' = J(`N',1,.) 

forvalues i = 1/`N'  {

mat `mat_new'[`i',1]= `M'[`i',`i']

}


mat rownames `mat_new'= `names' 

end



*graph_col , mat(comp_o_TA_m6_s3_FX) var(mother_divorced_by_5) label_var(piat-comprehension) values_x(6 8  10 12 ) path(C:\Users\Francisco\Dropbox\second_year_paper\shocks\graphs\coefficients) save(prueba) title(early divorce - piat comprehension) xtitle(age) moving_average



cap program drop graph_col
program define graph_col



syntax , mat(string) var(string) label_var(string) values_x(numlist)  [ path(string) title(string) moving_average moving_average_2 yrange(numlist)] save(string)  subtitle(string) xtitle(string) xline(string) yline(numlist) type(string)



*preserve 

drop _all

svmat `mat', names(col) 

keep `var'


gen moving_average = `var' if _n==1


loc m= _N

forvalues i = 2/`m' {

replace moving_average = (`var'+`var'[_n-1])/2 if _n==`i'


}


gen moving_average_2 = `var' if _n==1
replace moving_average_2 = moving_average if _n==2


forvalues i = 3/`m' {

replace moving_average_2 = (`var'+`var'[_n-1]+ `var'[_n-2])/3 if _n==`i'


}







label var `var' "`label_var'"
label var moving_average"`label_var'  (M.A.)"
label var moving_average_2 "`label_var'  (M.A.2)"

tokenize `values_x'


gen _x = .

forvalues i = 1/`m' {


replace _x = ``i'' if _n ==`i'

}





di "1= `1'"



/*
cap label drop _x

label define _x 1 "`1'"



forvalues i = 2/`m' {


label define _x `i' "``i''", add


}




label values _x _x

*/


loc y `var'


if "`moving_average'" !="" loc y moving_average
if "`moving_average_2'" !="" loc y moving_average_2


	twoway (`type' `y' _x), ytitle(`title')  xlabel(, valuelabel)   xline(`xline', lpattern(solid) lcolor(pink)) xtitle(`xtitle') title(`title') subtitle(`subtitle') yscale(range(`yrange')) yline(`yline', lwidth(vvvthin) lpattern(dash) lcolor(black))  ylabel(none) ylabel(#3, tlwidth(medthin) grid gmin gmax)

 

cap 	graph export "`path'\\`save'.png", replace
cap 	graph export "`save'.png", replace
cap 	graph save "`path'\\`save'.gph", replace
cap 	graph save "`save'.gph", replace




*restore

end













cap program drop sub_vector
program define sub_vector

syntax , beta(string) vars(varlist) mat(string)

count_word_list `vars'

*loc rows = r(count)



mat `mat'=J(r(count),1,.)

mat rownames `mat' =`vars' 



loc r = 0 

foreach var in `vars'{


	loc ++r


		local c=colnumb(`beta',"`var'")
		di  "`var'=  " `beta'[1,`c']
		mat `mat'[`r',1]=`beta'[1,`c']


		}


	





end



* same_regressor , betas(comp_o_3_TA_m6_s3 comp_o_4_TA_m6_s3) vars(mother_divorced_by_5 mother_divorced_by_6_10 mother_divorced_by_11_14) mat(prueba)

cap program drop same_regressor
program define same_regressor

syntax , betas(string) vars(varlist) mat(string) path(string)

count_word_list `betas'
loc rows = r(count)



count_word_list `vars'

loc cols = r(count)



mat `mat'=J(`rows', `cols',.)

mat colnames `mat' =`vars' 
mat rownames `mat' =`betas' 




loc n_c = 0 

foreach var in `vars'{


	loc ++n_c

loc n_r 0 
foreach beta in `betas'{

loc ++n_r


		local c=colnumb(`beta',"`var'")
		di  "`var'=  " `beta'[1,`c']
		mat `mat'[`n_r',`n_c']=`beta'[1,`c']


		}


	

}



mat list `mat'


export_mat `mat', save(`path'//`mat'.dta) 



end









* sub_vector , beta(beta) vars(var_a var_c) mat(prueba)




cap program drop check
program define check

syntax varlist


tokenize `varlist'

bysort `1': tab `2', m

end




cap program drop count_list 
program define count_list, rclass


syntax varlist

local count 0 
foreach i in `varlist' {

loc ++count

}

di "N of words in varlist: " `count'
ret scalar count = `count'


end



cap program drop count_word_list 
program define count_word_list, rclass


syntax anything 

local count 0 
foreach i in `anything' {

loc ++count

}

di "N of words in varlist: " `count'
ret scalar count = `count'


end


cap program drop bottom_of_distribution 
program define bottom_of_distribution 
syntax [if] [fweight], sort(varlist) percentage(real) gen(string) population(string) sortpreserve

* Observations employed 
tempvar sirve

* =1 if `sirve'
mark `sirve' `if' 

* 0 if sort is missing
markout `sirve' `sort'


local wt : word 2 of `exp'

if "`wt'"=="" {
local wt = 1
}




tempvar aux_sort acumulated aux_acumulated weight 


* sort variable
gen `aux_sort' = `sort' if `sirve'==1
sort `aux_sort'


* total observations



gen `weight'= `wt'
sum `weight' if (`population')  
loc TOT = r(sum)


* acumulated distribustion
gen `aux_acumulated' = `weight'/`TOT' if `sirve'==1
gen `acumulated' =sum(`aux_acumulated') 



gen `gen' = (`acumulated'<`percentage')




end 









* groups age if male==1, gen(male_age_groups) values(20 30 40 50 )

 

* tablas
cap program drop groups 
program define groups 
syntax varlist [if], gen(string) values(numlist)  [ short_labels(string) ]

* para no usar el if
tempvar sirve
mark `sirve' `if' 


tokenize `values'
loc n_values= wordcount("`values'") 



gen `gen'= .

forvalues i=1/`n_values'{

local j = `i' + 1

if `i' < `n_values' {
		replace `gen' = `i'  if ``i'' <=`varlist' & `varlist'<``j''     & `sirve'==1  

		
if "`short_labels'" ==""		cap label define `gen'_LAB `i' "``i''<=`varlist'<``j'' "
if "`short_labels'" ==""		cap label define `gen'_LAB `i' "``i''<=`varlist'<``j'' ", add

if "`short_labels'" !=""		cap label define `gen'_LAB `i' "``i''-``j'' "
if "`short_labels'" !=""		cap label define `gen'_LAB `i' "``i''-``j'' ", add

}

else {

		replace `gen' = `i'  if ``i'' <=`varlist' & `varlist'<.  & `sirve'==1  
if "`short_labels'" ==""		cap label define `gen'_LAB `i' "`varlist'>``i''", add
if "`short_labels'" !=""		cap label define `gen'_LAB `i' ">``i''", add


}


}


label values `gen' `gen'_LAB 




end




cap program drop groups2 
program define groups2 
syntax varlist [if], gen(string) values(numlist)   short_labels(string) 

* para no usar el if
tempvar sirve
mark `sirve' `if' 


tokenize `values'
loc n_values= wordcount("`values'") 



gen `gen'= .

forvalues i=1/`n_values'{

local j = `i' + 1

if `i' < `n_values' {
		replace `gen' = `i'  if ``i'' <=`varlist' & `varlist'<``j''     & `sirve'==1  

		
if "`short_labels'" ==""		cap label define `gen'_LAB `i' "``i''<=`varlist'<``j'' "
if "`short_labels'" ==""		cap label define `gen'_LAB `i' "``i''<=`varlist'<``j'' ", add

if "`short_labels'" !=""		cap label define `gen'_LAB `i' "``i''-``j'' "
if "`short_labels'" !=""		cap label define `gen'_LAB `i' "``i''-``j'' ", add

}

else {

		replace `gen' = `i'  if ``i'' <=`varlist' & `varlist'<.  & `sirve'==1  
if "`short_labels'" ==""		cap label define `gen'_LAB `i' "`varlist'>``i''", add
if "`short_labels'" !=""		cap label define `gen'_LAB `i' ">``i''", add


}


}


label values `gen' `gen'_LAB 




end




cap program drop export_mat
program define export_mat

syntax namelist, save(string) [note(string) row_names(string) saveold]


preserve
drop _all
cap svmat `namelist', names(col)
if _rc svmat `namelist'




if "`row_names'"!= ""  {

gen names= ""
local r 0 
foreach  x in `row_names' {

loc ++r

replace names = "`x'" if _n==`r'


}

order names



}






di          substr("`save'",-3,3)
loc type =  substr("`save'",-3,3)


if "`note'" !="" & "`type'" ==  "xls" {


gen blank1 = ""
gen blank2 = "note: `note'" if _n==_N

}  


if "`type'" !=  "dta"  loc type "xls"


local save_type "save"
if "`saveold'"!="" local save_type "saveold"




if ("`type'" ==  "xls")|"`type'" ==  "csv" outsheet using "`save'", replace
if "`type'" ==  "dta" `save_type' "`save'", replace



restore
end 












* instead of this program , we should use this command: levelsof  var,  local(mylevs)

cap program drop valores_var
program define valores_var, rclass 
syntax varlist [if] 

tempname A
qui tab `varlist' `if', matrow(`A')
loc max=r(r)


forvalues i=1/`max' {

loc val=`A'[`i',1]
loc values "`values' `val'"


}

ret local values "`values'"


end


* Este programa de dice la cantidad de valores que toma una variable
* (o combinaciones de variables)



cap program drop qq
program define qq, rclass 


syntax varlist [if] 



tempvar order

gen `order' = _n


sort `varlist'

tempvar aux


egen `aux'=group(`varlist') `if'

qui sum `aux' 

loc max=r(max)
di in yellow  "Numb. of Obs: "  r(N) 

di in yellow "valores / combinaciones en ... `varlist' ========>  " `max'



return scalar N_values =`max'


sort `order'


end




cap program drop q_val
program define q_val, rclass 


syntax varlist [if] , sortpreserve



sort `varlist'

tempvar aux


egen `aux'=group(`varlist') `if'

qui sum `aux' 

loc max=r(max)
di in yellow  "Numb. of Obs: "  r(N) 

di in yellow "valores / combinaciones en ... `varlist' ========>  " `max'



return scalar N_values =`max'




end



* tablas
cap program drop dummies
program define dummies
syntax varlist [if], gen(string) [OMITIR_1st]




qui {

* para no usar el if
tempvar sirve
mark `sirve' `if' 


* tempname
tempname codigos


sum `varlist'

if r(N)>0 {

tab `varlist' if `sirve'==1, matrow(`codigos') 



* number of potential region in by()

loc max =rowsof(`codigos')


* fisrt value of the loop

			local fst 1
if "`omitir_1st'" != "" local fst 2

	forvalues c=`fst'(1)`max' {

 

        loc dummy=`codigos'[`c',1]          

        loc name = `dummy' 
        
          

           

        if `dummy' <0 {
	
	loc abs = abs(`dummy') 
        local name "neg`abs'" 

	} 

*	Dummy para `dummy'	
	gen `gen'_`name'=0 if  `sirve' == 1 & `varlist'!=.
        replace `gen'_`name' =1  if `sirve' == 1 & `varlist'==`codigos'[`c',1]
        
	cap label_value , labelvar(`varlist') value(`dummy') 
         
        local label ""
        cap local label = r(label)

        cap if r(label) != "." label var `gen'_`name' "`label'"
        cap if r(label) == "." label var `gen'_`name' "`varlist'=`dummy'"
        

        cap if r(label) != . label var `gen'_`name' "`label'"
        cap if r(label) == . label var `gen'_`name' "`varlist'=`dummy'"
        


        }



}







}  // cierra el qui

end





cap program drop household_var
program define household_var, rclass 

syntax  [if], hh_id(varlist) [vars(varlist) member(varlist) prefix(string) stat(string) prop_condition(string) prop_var(string)] 


tempvar sirve
mark `sirve' `if'


sum  `sirve' 

di "N obs in sirve: " r(N)


foreach var in `vars'  {


if "`member'" != "" {
tempvar aux_`var'
gen `aux_`var''   =`var' if `member'==1 & `sirve' ==1
egen `prefix'_`var' = max(`aux_`var'') if `sirve' ==1 , by(`hh_id')
}

if  "`stat'" != "" {
egen `prefix'_`var' = `stat'(`var') if  `sirve' ==1 , by(`hh_id')
}

}


if  "`prop_condition'" != "" {


tempvar hhsize one sum_ones

gen `hhsize'=.

bysort `hh_id': replace `hhsize'=_N  if  `sirve' ==1 

gen `one' = (`prop_condition') if  `sirve' ==1 

egen `sum_ones' = sum(`one') if `sirve' ==1 , by(`hh_id')

gen `prop_var'=`sum_ones'/`hhsize' if `sirve' ==1 


}



end

* ==========================================================================================================

* Checks id
* =========

	version 8
	cap program drop chequea_id
	program define chequea_id, rclass

	syntax varlist
         
	tempvar aux 
        loc num=0
	preserve
	sort `varlist'

	egen `aux' =group(`varlist') 
	qui sum `aux' 

	if r(max)==r(N) di in yellow "THIS IS THE ID"
	if r(max)==r(N) loc num=1
        
	   
	return scalar id = `num'

	restore  

	end





* program: matrix to graph var
*=======================================================================================================*

* tablas
cap program drop graph_bar_vector
program define graph_bar_vector 
syntax, vector(namelist) [label_x(string) xtitle(string) title(string)  subtitle(string) ytitle(string) scatter] 


* keep original dataset
preserve

* matrix to data 
drop _all
svmat `vector'

* labels
gen id=_n
loc N=_N



if "`label_x'" !="" {

tempname label

tokenize `label_x' 

forvalues r= 1/`N' {

*if  `r'==1 label define `label' `r' "``r''"
*if  `r'!=1  label define `label' `r' "``r''", add

local L = regexr("``r''","_"," ")

if  `r'==1 label define `label' `r'  "`L'"
if  `r'!=1  label define `label' `r' "`L'", add


}




label values id `label'





}




graph bar (mean) `vector'1 , over(id) title("`title'") subtitle("`subtitle'") ytitle(`ytitle') scheme(s2mono)  caption(`xtitle', position(5))

if "`scatter'"!= "" scatter `vector'1 id , title("`title'") subtitle("`subtitle'") ytitle(`ytitle') scheme(s2mono)  caption(`xtitle', position(5))  

end



*graph_bar_vector , vector(A)  label_x(uno dos tres cuatro cinco) title(beneficiaries) subtitle(sample x) xtitle(quintiles) ytitle(% of benef.) 



* tablas
cap program drop label_value
program define label_value, rclass
syntax [if], labelvar(varlist) value(real) 



tempvar n lab

tempvar sirve
mark `sirve' `if' 



gen `n'=_n if `labelvar'==`value' & `sirve'==1
sum `n'
loc posi = r(min)
decode `labelvar' if `labelvar'==`value' & `sirve'==1, gen(`lab') 
loc aux=`lab'[`posi']
return local label="`aux'"




end



* long to wide
* ============


cap program drop long_to_wide
program define long_to_wide, rclass

syntax varlist [if], id(varlist) j(varlist) 
	
keep `varlist' `id' `j'

levelsof `j' `if', local(val_j)

tempfile temp
save `temp'


* datasets by vars
foreach v in `val_j' {
drop _all
use `temp'

keep if `j'==`v'

foreach var in `varlist' {

rename `var' `var'_`v' 

}

tempfile t`v'
save `t`v''

}




local n = 0
* merge
foreach v in `val_j' {



local ++n 

if `n'==1 use `t`v''

cap drop _merge
sort `id'

if `n'!=1 merge (`id') using  `t`v''
cap drop _merge




}


drop `j'




end






* programs
version 8
cap program drop check_1
program define check_1

syntax varlist(max=1) [fweight] [if] [, N_sd(numlist) Exch(numlist) Graph GEn_out(string) title(string) subtitle(string)] 
 


tempvar sirve 

* si `if' est vacio sirven todas
mark `sirve' `if' 
* le quita el 1 a sirve si `1' es missing
markout `sirve' `1'






* Denominator
local den=1

* Currency
local curr "LMU"



if "`exch'"!="" loc den `exch' 

if "`exch'"!="" loc curr "USD"



* statistics

qui sum `varlist' if `sirve'==1     , d
local sd=r(sd)
local mean=r(mean)


di
di
di in red "statistics in `curr': var `varlist'"
di
di
di

di in green "extremos inferiores"
di in yellow "min      : " r(min)/`den'
di in yellow "percen 1 : " r(p1)/`den'
di
di
di in green "centro"
di in yellow "mediana  : " r(p50)/`den'
di in yellow "prom     : " r(mean)/`den'

di
di
di in green "extremos superiores"
di in yellow "percen 99 : " r(p99)/`den'
di in yellow "max      : " r(max)/`den'
di _n _n _n _n _n 



tempvar aux

qui gen `aux'= 0 if `sirve'==1     
qui replace `aux' = 1 if (`mean'-`sd'*`n_sd')<`varlist'  & `varlist'<(`mean'+`sd'*`n_sd') & `sirve'==1     

qui sum `aux'
di _n _n _n _n _n 
di in yellow "PERCENTAGE IN X +/- `n_sd' sd: " r(mean)*100 


if "`gen_out'" != "" {

gen `gen_out'=1 if `aux'==0
qui sum `gen_out'
local n_out = r(N)

di "No Outliers: " r(N)


di _n  _n  _n  _n  _n  



*if "`graph'"!="" graph7 `varlist' `varlist'  if `sirve'==1 


*if "`graph'"!="" graph7 `varlist' `varlist'  if `sirve'==1  & `gen_out'!=1

tempfile g1 g2

if "`graph'"!="" graph box `varlist' if `sirve'==1  , saving(g1, replace) title(WITH) 

if "`graph'"!="" graph box `varlist' if `sirve'==1  & `gen_out'!=1 , saving(g2, replace) title(WITHOUT)

if "`graph'"!="" graph combine g1.gph g2.gph, title(`title')  subtitle(`subtitle')  saving(graph, replace) caption(Note: No ouliers =`n_out' (more than `n_sd' SD))





}


end











* program: matrix to graph var
*=======================================================================================================*

* tablas
cap program drop graph_bar_two
program define graph_bar_two 
syntax, vectors(namelist) [label_x(string) xtitle(string) title(string)  series_name(string)  subtitle(string) ytitle(string) ] 


* keep original dataset
preserve

* matrix to data 


tokenize `vectors'

forvalues i = 1/2 {

drop _all

svmat ``i''


foreach var of varlist  * {

rename `var' var`i' 

}


gen id=_n

loc N=_N

sort id

tempfile B`i'

save `B`i''

}


use `B1'

merge (id) using `B2'

tab _m

drop _m






if "`label_x'" !="" {

tempname label

tokenize `label_x' 

forvalues r= 1/`N' {

*if  `r'==1 label define `label' `r' "``r''"
*if  `r'!=1  label define `label' `r' "``r''", add

local L = subinstr("``r''","_"," ",.)

if  `r'==1 label define `label' `r'  "`L'"
if  `r'!=1  label define `label' `r' "`L'", add


}




label values id `label'





}


tokenize `series_name'


forvalues r= 1/2 {


local L`r' = subinstr("``r''","_"," ",.)


}



graph bar (mean) var1 (mean) var2, over(id) title("`title'") subtitle("`subtitle'") ytitle(`ytitle') /*scheme(s2mono)*/  caption(`xtitle', position(5)) legend(on order(1 "`L1'" 2 "`L2'"))

end

/*
mat vector_A = [1\3\3\2] 
mat vector_B = [2\2\3\1] 



graph_bar_two , vectors(vector_A vector_B) label_x(R1 R2 R3 R4) xtitle(region) title(titulitoooo)  series_name(all_QQQQ_KKK QQQ1_JJJ_AAA)  subtitle(muestra) ytitle(hpci reduction)  
*/










version 8
cap program drop merge_lista
program define merge_lista


syntax anything ,  id(string) [keep(string) suffix(string)]

* separates in `1' `2'...
tokenize `anything'
local master "`1'"



* identifies `2', `3'...
macro shift
local aux `*'

* Sorts

local n 1 
foreach b in `aux' {

loc ++n

use `b'
cap drop _merge
tempvar sirve
mark `sirve' `keep'
keep if `sirve'==1
sort `id'


if "`suffix'" != "" {

tokenize `suffix'

add_suffix _all , suffix(``n'') exclude(`id') 


}

tempfile temp`b'
save `temp`b''

q_val `id', sortpreserve 


}



* open master
use `master'


if "`suffix'" != "" {

tokenize `suffix'

add_suffix _all , suffix(`1') exclude(`id') 


}



tempvar sirve
mark `sirve' `keep'
keep if `sirve'==1


* merge with list 
foreach b in `aux' {

di in yellow "merging with `b'"
* sort
sort `id'
cap drop _merge
merge (`id') using `temp`b''
tab _merge

}





end







version 8


*============================================================================*



* genera vector columna con promedios
cap program drop prom_x
program define prom_x



syntax varlist [fweight] [if], mat(string) 

qui {


* ponderador
local wt : word 2 of `exp'
tempvar pond

    if "`wt'"=="" {
      local wt = 1
    }


* N var
loc N=0

foreach var in `varlist' {

loc ++N

} /*( cierra loop por var)*/



* N var
mat `mat'= J(`N',1,.)


* identifica fila
loc f=0

foreach var in `varlist' {
loc ++f

sum `var' [`weight'`exp'] `if'
mat `mat'[`f',1]=r(mean)

/*(!!!!!!!!!!!!!!!!!!!  importante!!!!!!!!!!!!!!!!!!!!!!!!)*/


/* distingue edad-2

	if "`var'"=="edad2" {
	
	qui sum edad [`weight'`exp'] `if'
	mat `mat'[`f',1]=r(mean)^2


		            }

*/







} /*( cierra loop por var)*/


mat rownames `mat'= `varlist'  




}  /*( cierra el qui)*/

*prom_x edad hombre [w=pondera] if bog==1, mat(X)

end




version 8










cap program drop fill_mat
program define fill_mat 
syntax anything , mat(string)



local N = wordcount("`anything'")

tokenize `anything'

local n = (`N'/2)



	loc cuenta 0 

	forvalues i = 1/`n' {

	
        loc j = `cuenta'*2+1 
        
	loc v = `cuenta'*2+2 

	loc x = "``j''"



	local row =rownumb(`mat',"`x'")
	mat `mat'[`row',1]= ``v''

        
        loc ++cuenta 


	}




end




































cap program drop average_scalar
program define average_scalar, rclass 
syntax anything 

local N = wordcount("`anything'")

loc SUM = 0

foreach value in `anything' {

loc SUM = `SUM' + `value'

}

di in yellow "average= " in green `SUM'/`N'
ret scalar average= `SUM'/`N'


end


*#######################################################

* example: sample of 5% of household
* take_sample 5, id(id)

cap program drop take_sample
program define take_sample,  sortpreserve




syntax anything, id(varlist)  

di "sample `anything' %"



tempvar seq r r_hh N_hh N_hh_check

sort `id'
egen `seq' = seq(), by(`id') 
egen `N_hh' =max(`seq'), by(`id') 



gen `r' =uniform()*100 if `seq'==1
egen `r_hh' = max(`r'), by(`id')

keep if `r_hh'<`anything' 

egen `N_hh_check' =max(`seq'), by(`id') 

compare `N_hh_check'  `N_hh'

end 



cap program drop codes_in_macro 
cap program define codes_in_macro , rclass

syntax varlist (max=1)[if] 

tempvar sample 

tempname A

* =1 if `if'
mark `sample' `if' 


qui tab `varlist' if `sample'==1 , matrow(`A')
loc N = r(r)

forvalues i =1 /`N'  {

loc x="."

loc x=`A'[`i',1]

loc values "`values' `x'"

}

ret local values = "`values'"

end





/*

cap program drop MY_round
program define MY_round


syntax varlist, gen(string) 

tempvar int dec new_dec


gen `int' = int(`varlist')

gen `dec'= `varlist'-`int'


gen `new_dec'= .
forvalues i = 0(0.1)1 {

replace `new_dec'= `i' if `new_dec'==. & `dec'<(`i' +.05)

}


gen `gen' = `int' + `new_dec'
end

*MY_round  LFP_black_1950_BS_LN, gen(Y_rounded) 



*/


















cap program drop aux_isolation_index_II
program define aux_isolation_index_II, rclass

syntax [if], share(varlist) tract_group_pop(varlist)



tempvar w w_x_share

di "sum `tract_group_pop' `if'"
qui sum `tract_group_pop' `if'

local N = r(sum)

qui gen `w'= `tract_group_pop'/`N' `if'

qui sum `w'

di "weights add to " r(sum)

qui gen `w_x_share'= `w'*`share'  `if'

qui sum `w_x_share'  `if'

ret scalar isolation_index = r(sum)


di in green _n(10)  "isolation index = " in yellow r(sum)  _n(10)  

end




cap program drop isolation_index_II
program define isolation_index_II, rclass

syntax [if], share(varlist) tract_group_pop(varlist) [by(varlist)]

tempvar sirve 

mark `sirve' `if'

if "`by'"=="" {

aux_isolation_index_II `if', share(`share') tract_group_pop(`tract_group_pop')
return scalar isolation_index= r(isolation_index)
}

else {

levelsof `by', local(list) 


gen __Isolation = . 

foreach m in `list' {



di in green "m = " in yellow "`m'"
qui aux_isolation_index_II if `sirve'==1 & `by'==`m' , share(`share') tract_group_pop(`tract_group_pop')

qui replace  __Isolation = r(isolation_index) if `sirve'==1 & `by'==`m'



}





}










end









cap program drop labels_values_to_x
program define labels_values_to_x




syntax varlist (max=1), save(string) [blank id_value]

preserve

gen labels = ""


levelsof `varlist', local(levels)


loc n 0 

if "`id_value'"!="" {

gen id_value = . 


}



foreach x in `levels' {

loc ++n 



qui	label_value , labelvar(`varlist') value(`x') 
         
        

        
	
	loc lab`x' =  r(label)

replace labels = "`lab`x''" if _n == `n'


if "`id_value'"!="" {

replace id_value = `x' if  _n == `n'

}


}

gen id = _n





keep if id <=`n'


if "`id_value'"!="" {

loc keep_id_value "id_value"

}

keep label id `keep_id_value'



loc type =  substr("`save'",-3,3)



if "`type'" ==  "xls" outsheet using "`save'", replace
else  save "`save'", replace

restore
end





cap program drop break_string
program define  break_string


syntax varlist, string(string) gen_var1(string) gen_var2(string)




confirm string var `varlist'


loc N = _N

gen `gen_var1' = ""
gen `gen_var2' = ""

forvalues n = 1/`N'  {

local value_n =`varlist'[`n'] 
local position = strpos("`value_n'","`string'")

loc str1 =substr("`value_n'",1,`position' - 1)
loc str2 =substr("`value_n'",`position' + 1,.)

replace  `gen_var1' = "`str1'" if _n ==`n'
replace  `gen_var2' = "`str2'" if _n ==`n'



}






end





* groups age if male==1, gen(male_age_groups) values(20 30 40 50 )

 

* categories by values
* groups age if male==1, gen(male_age_groups) values(20 30 40 50 )

cap program drop groups 
program define groups 
syntax varlist [if], gen(string) values(numlist)

* para no usar el if
tempvar sirve
mark `sirve' `if' 


tokenize `values'
loc n_values= wordcount("`values'") 



gen `gen'= .

forvalues i=1/`n_values'{

local j = `i' + 1

if `i' < `n_values' {
		replace `gen' = `i'  if ``i'' <=`varlist' & `varlist'<``j''     & `sirve'==1  
		cap label define `gen'_LAB `i' "``i''<=`varlist'<``j'' "
		cap label define `gen'_LAB `i' "``i''<=`varlist'<``j'' ", add
}

else {

		replace `gen' = `i'  if ``i'' <=`varlist' & `varlist'<.  & `sirve'==1  
		cap label define `gen'_LAB `i' "`varlist'>``i''", add


}


}


label values `gen' `gen'_LAB 




end




*===================================================================*
* cuantiles.do                                                      *
*===================================================================*

* ultima revision
* 10/1/2005
* 27/1/2006

capture program drop cuantiles

program define cuantiles
  version 7.0
  syntax varlist(max=1) [if] [fweight], Ncuantiles(integer) Generate(namelist) [orden_aux(varlist)]
  tokenize `varlist'
  
  quietly {

    * cuantiles en, por ejemplo, d_ipcf
    local quanpers="`generate'"
    
    tempvar suma mipondera mivar
  
    local wt : word 2 of `exp'
    if "`wt'"=="" {
      local wt = 1
    }  

    gen `mivar'=.
    replace `mivar'=`1' `if' 
    * ojo con los missing!
    * no lo puedo hacer en la linea anterior porque la macro local if incluye la palabra "if"
    replace `mivar'=. if `1'==.

    sort `mivar' `orden_aux'
    
    gen `mipondera'=`wt'
    replace `mipondera'=0 if `mivar'==.     
    gen `suma'=sum(`mipondera')

    *ppquan = Personas Por Quantil
    *ppquan es el nmero de personas que debera tener cada quantil

    summ `mipondera', meanonly
    
    scalar ppquan = r(sum)/`ncuantiles'
    generate `quanpers'=.
    
    forvalues i=1(1)`ncuantiles' {
      display `i'
      replace `quanpers'=`i' if `suma'>(`i'-1)*ppquan & `suma'<=`i'*ppquan & `mivar'!=. 
    }
 
  }
  tabulate `quanpers' [`weight'`exp'], summ(`1')
 
end








version 8
cap program drop asteriscos
program define asteriscos
syntax varlist, pvalue(varlist) ndec(numlist) gen(namelist) [3ast]





* round the data 
*================================================================================

local aux_dec=1/(10^`ndec')


tempvar round
gen `round'=round(`varlist',`aux_dec') 

gen `gen' = string(`round')  
replace `gen' = "0"+ `gen' if `varlist'>=0 & `varlist'<1  
replace `gen' = subinstr(`gen',"-.","-0.",1)

* add asterisks
*================================================================================
if "`3ast'"!= "" {

replace `gen'= `gen'+"*"   if `pvalue'>0.05 & `pvalue'<=0.1  
replace `gen'= `gen'+"**"  if `pvalue'>0.01 & `pvalue'<=0.05  
replace `gen'= `gen'+"***" if		      `pvalue'<=0.01  

}

if "`3ast'"== "" {

replace `gen'= `gen'+"*"  if `pvalue'>0.01 & `pvalue'<=0.05  
replace `gen'= `gen'+"**" if		      `pvalue'<=0.01  

}

end






