*ATTENTION:
*change PC_FOLDER to the path where folder "chapter 3" is located on your computer
*example provided below
* pc folder
local PC_FOLDER "/Users/zhangjiwei/Desktop/UCLA/Boustan/Summer/Replication files/chapter 3"

cd "`PC_FOLDER'/figure_3.2/creating_4070merge_educ_dta"

clear

/* This do file will merge together data from 1940, 50, 60 and 70 to run a Borjas-style analysis.  It will also create the 
necessary dummy variables.*/

use 1940b02_educ.dta
gen year=1940
append using 1950b02_educ.dta
replace year=1950 if year==.
append using 1960b02_educ.dta
replace year=1960 if year==.
append using 1970b02_educ.dta
replace year=1970 if year==.
*append using 1980b02_educ.dta
*replace year=1980 if year==.
egen group=group(edcat expcat)

xi, pre(a) i.edcat*i.year
xi, pre(b) i.expcat*i.year
xi, pre(c) i.expcat*i.edcat
drop cedcat* cexpcat* byear*

gen count_all=countbnmi+countwnmi
gen lncount=ln(count_all)
gen lnearn_mean_bnmi=lnearn if black==1 & migsouth==0
gen lnearn_mean_bmi=lnearn if black==1 & migsouth==1
gen lnearn_mean_wnmi=lnearn if black==0 & migsouth==0
sort group year 
quietly by group year: egen white=max(lnearn_mean_wnmi)
quietly by group year: egen blackmig=max(lnearn_mean_bmi)
*replace lnearn_mean_bnmi=blackmig if countbnmi01<5 & black==1 & migsouth==0
gen diff=lnearn_mean_bnmi-white if black==1 & migsouth==0
replace perbnins=. if black==0 | migsouth==1
replace perwnins=. if black==1 | migsouth==1

gen dlncountbw=ln(countb/(count-countb))
gen dlncountbwmi=ln(countbmi/countwmi)
gen dlncountbws=ln(countbsouth/countwsouth)
gen dlncountbwsa=ln(countbsouth_a/countwsouth_a)


save 4070merge_educ.dta, replace

