*ATTENTION:
*change PC_FOLDER to the path where folder "chapter 3" is located on your computer
*example provided below
* pc folder
local PC_FOLDER "/Users/zhangjiwei/Desktop/UCLA/Boustan/Summer/Replication files/chapter 3"

cd "`PC_FOLDER'/figure_3.2"

/* This do file produces the results underlying the tables in the Oct 31st 2007 version of the draft "Competition in the 
Promised Land"*/

*capture log close
*log using results_1031.log, replace
clear
use 4070merge_educ.dta
set more off
gen lncountb=ln(countb)
gen lncountw=ln(countwnmi+countwmi)
gen lncountbmi=ln(countbmi)
gen lncountwmi=ln(countwmi)
gen lncountbs=ln(countbsouth)
gen lncountws=ln(countwsouth)
*gen lncountbsa=ln(countbsouth_a)
*gen lncountwsa=ln(countwsouth_a)
replace count=countbnmi01+countwnmi01

*reg lncountb lncountw aedcat_2-cexpXedc_8_5 [aw=count] if black==1 & migsouth==1, cluster(group)
*reg lncountbmi lncountwmi aedcat_2-cexpXedc_8_5 [aw=count] if black==1 & migsouth==1, cluster(group)


/*Table 2*/
/* OLS - row 1*/
reg diff lncountb lncountw aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg diff dlncountbw aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg lnearn_mean_bnmi lncountb lncountw aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg lnearn_mean_bnmi dlncountbw aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg lnearn_mean_wnmi lncountb lncountw aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg lnearn_mean_wnmi dlncountbw aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
/* Instead of first IV, use migrants in OLS*/
reg diff lncountbmi lncountwmi aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg diff dlncountbwmi aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg lnearn_mean_bnmi lncountbmi lncountwmi aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg lnearn_mean_bnmi dlncountbwmi aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg lnearn_mean_wnmi lncountbmi lncountwmi aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
reg lnearn_mean_wnmi dlncountbwmi aedcat_2-cexpXedc_8_5 [aw=count], cluster(group)
/* First IV - row 2*/
ivreg diff aedcat_2-cexpXedc_8_5 (lncountb lncountw = lncountbmi lncountwmi) [aw=count], cluster(group) first
reg lncountb lncountbmi lncountwmi aedcat_2-cexpXedc_8_5 [aw=count] if black==1 & migsouth==0, cluster(group)
reg lncountw lncountbmi lncountwmi aedcat_2-cexpXedc_8_5 [aw=count] if black==1 & migsouth==0, cluster(group)
reg dlncountbw lncountbmi lncountwmi aedcat_2-cexpXedc_8_5 [aw=count] if black==1 & migsouth==0, cluster(group)
ivreg diff aedcat_2-cexpXedc_8_5 (dlncountbw = lncountbmi lncountwmi) [aw=count], cluster(group) first
ivreg diff aedcat_2-cexpXedc_8_5 (dlncountbw = lncountbmi) [aw=count], cluster(group) 
ivreg lnearn_mean_bnmi aedcat_2-cexpXedc_8_5 (lncountb lncountw = lncountbmi lncountwmi) [aw=count], cluster(group)
ivreg lnearn_mean_bnmi aedcat_2-cexpXedc_8_5 (dlncountbw = lncountbmi lncountwmi) [aw=count], cluster(group)
ivreg lnearn_mean_wnmi aedcat_2-cexpXedc_8_5 (lncountb lncountw = lncountbmi lncountwmi) [aw=count], cluster(group)
ivreg lnearn_mean_wnmi aedcat_2-cexpXedc_8_5 (dlncountbw = lncountbmi lncountwmi) [aw=count], cluster(group)

/* Second IV - row 3*/
ivreg diff aedcat_2-cexpXedc_8_5 (lncountbmi lncountwmi = lncountbs lncountws) [aw=count], cluster(group) first
ivreg diff aedcat_2-cexpXedc_8_5 (dlncountbwmi = lncountbs lncountws) [aw=count], cluster(group) first
ivreg lnearn_mean_bnmi aedcat_2-cexpXedc_8_5 (lncountbmi lncountwmi = lncountbs lncountws) [aw=count], cluster(group)
ivreg lnearn_mean_bnmi aedcat_2-cexpXedc_8_5 (dlncountbwmi = lncountbs lncountws) [aw=count], cluster(group)
ivreg lnearn_mean_wnmi aedcat_2-cexpXedc_8_5 (lncountbmi lncountwmi = lncountbs lncountws) [aw=count], cluster(group)
ivreg lnearn_mean_wnmi aedcat_2-cexpXedc_8_5 (dlncountbwmi = lncountbs lncountws) [aw=count], cluster(group)

/*Table 4*/
/* OLS - row 1*/
reg perbnins dlncountbw aedcat_2-cexpXedc_8_5 [aw=countbnmi], cluster(group)
reg perbnins lncountb lncountw aedcat_2-cexpXedc_8_5 [aw=countbnmi], cluster(group)
reg perwnins dlncountbw aedcat_2-cexpXedc_8_5 [aw=countwnmi], cluster(group)
reg perwnins lncountb lncountw aedcat_2-cexpXedc_8_5 [aw=countwnmi], cluster(group)
/* First IV - row 2*/
ivreg perbnins aedcat_2-cexpXedc_8_5 (dlncountbw = lncountbmi lncountwmi) [aw=countbnmi], cluster(group)
ivreg perbnins aedcat_2-cexpXedc_8_5 (lncountb lncountw = lncountbmi lncountwmi) [aw=countbnmi], cluster(group)
ivreg perwnins aedcat_2-cexpXedc_8_5 (dlncountbw = lncountbmi lncountwmi) [aw=countwnmi], cluster(group)
ivreg perwnins aedcat_2-cexpXedc_8_5 (lncountb lncountw = lncountbmi lncountwmi) [aw=countwnmi], cluster(group)

/* Table 6: Robustness*/
* Could do by time period as well
reg diff dlncountbwmi aedcat_2-cexpXedc_8_5 [aw=countbnmi01], cluster(group)
reg diff dlncountbwmi aedcat_2-cexpXedc_8_5 if countbnmi01>25, cluster(group)
reg diff dlncountbwmi aedcat_2-cexpXedc_8_5 if edcat>1, cluster(group)
reg diff dlncountbwmi aedcat_2-cexpXedc_8_5 if edcat<5, cluster(group)


*log close
***/
